=== modified file 'NEWS'
--- NEWS	2010-05-24 01:05:14 +0000
+++ NEWS	2010-05-31 21:31:18 +0000
@@ -5,10 +5,60 @@
 .. contents:: List of Releases
    :depth: 1
 
+bzr 2.2b4
+#########
+
+:Codename: Monkey Magic
+:2.2b4: NOT RELEASED YET
+
+Compatibility Breaks
+********************
+
+New Features
+************
+
+Bug Fixes
+*********
+
+* Final fix for 'no help for command' issue. We now show a clean message
+  when a command has no help, document how to set help more clearly, and
+  test that all commands available to the test suite have help.
+  (Robert Collins, #177500)
+
+Improvements
+************
+
+Documentation
+*************
+
+* Improved our release checklist to have a bit less churn and leave things
+  ready-to-go for the next action (including other people doing
+  development). (Robert Collins)
+
+API Changes
+***********
+
+Internals
+*********
+
+Testing
+*******
+
+
 bzr 2.2b3
 #########
 
-:2.2b3: NOT RELEASED YET
+:2.2b3: 2010-05-28
+
+This third beta in the 2.2 series brings with it all the goodness of 2.1.2
+and 2.0.6 (though it preceeds 2.0.6 slightly). Of particular note for
+users are compatibility fixes with bzr 1.5 and below servers, a hopeful
+end to the EINTR errors caused by SIGWINCH interactions, a shiny new
+bash completion script and bzr will no longer guess at identity details -
+it was too unreliable in reality. Use ``bzr whoami`` on every new install.
+For developers we have some API changes which may impact plugins as well
+as a bunch of our regular improvements to internal clarity and test
+support.
 
 Compatibility Breaks
 ********************
@@ -27,7 +77,12 @@
   (Parth Malwankar, #549310)
 
 * ``bzrlib.commands.Command`` will now raise ValueError during
-  construction if there is no __doc__ set. (Robert Collins)
+  construction if there is no __doc__ set. (Note, this will be reverted in
+  2.2b4) (Robert Collins)
+
+* The source tree no longer contains a contrib/zsh/_bzr completion
+  script. The new file contrib/zsh/README suggests alternatives.
+  (Martin von Gagern, #560030)
 
 New Features
 ************
@@ -61,9 +116,19 @@
   replaces the outdated ``contrib/bash/bzr`` script with a version
   using the plugin. (Martin von Gagern, #560030)
 
+* A new transport based on GIO (the gnome i/o library) provides access to
+  samba shares, webdav using gio+smb and gio+dav. It is also possible to
+  use gio for some already existing transport methods as gio+file,
+  gio+sftp, gio+ftp. 
+  (Mattias Eriksson)
+
 Bug Fixes
 *********
 
+* Alias information shown by ``bzr help`` is now accurate. This
+  was showing an internal object name for some plugin aliases.
+  (Parth Malwankar, #584650)
+
 * ``.bazaar``, ``.bazaar/bazaar.conf`` and ``.bzr.log`` inherit user and
   group ownership from the containing directory. This allow bzr to work
   better with sudo.
@@ -100,6 +165,12 @@
 * CommitBuilder refuses to create revisions whose trees have no root.
   (Aaron Bentley)
 
+* Do not register a SIGWINCH signal handler, instead just poll for the
+  terminal width as needed.  This avoids the "Interrupted System Call"
+  problems that occur on POSIX with all currently released versions of
+  Python.
+  (Andrew Bennetts, #583941)
+
 * Don't mention --no-strict when we just issue the warning about unclean trees.
   (Vincent Ladeuil, #401599)
 
@@ -174,6 +245,12 @@
   be interpreted as a boolean.
   (Vincent Ladeuil)
 
+* The all-in-one Windows installer will now be built with docstrings stripped
+  from the library zip, reducing the size and slightly improving cold startup
+  time. Bundled plugins are unchanged for the moment, but if adding other new
+  plugins to an all-in-one installation, ensure they are compiled and
+  installed with -O1 or help may not work. (Martin [gz])
+
 Documentation
 *************
 
@@ -251,6 +328,10 @@
   failures on Lucid, FreeBSD and gentoo.  
   (Vincent Ladeuil, #528436)
 
+* New class ``ExecutableFeature`` for checking the availability of
+  executables on the ``PATH``. Migrated from bash_completion plugin.
+  (Martin von Gagern)
+
 bzr 2.2b2
 #########
 
@@ -310,7 +391,7 @@
 * Reset ``siginterrupt`` flag to False every time we handle a signal
   installed with ``set_signal_handler(..., restart_syscall=True)`` (from
   ``bzrlib.osutils``.  Reduces the likelihood of "Interrupted System Call"
-  errors after two window resizes.
+  errors compared to registering ``signal.signal`` directly.
   (Andrew Bennetts)
 
 * When invoked with a range revision, ``bzr log`` doesn't show revisions
@@ -659,7 +740,11 @@
 bzr 2.1.2
 #########
 
-:2.1.2: NOT RELEASED YET
+:2.1.2: 2010-05-28
+
+This release fixes two critical networking issues with older servers and
+with interrupted system call errors when pushing or pulling.  We recommend
+upgrading to anyone running a 2.1.x version of bzr.
 
 Bug Fixes
 *********
@@ -671,6 +756,12 @@
 * ``bzr switch`` does not die if a ConfigurableFileMerger is used.
   (Aaron Bentley, #559436)
 
+* Do not register a SIGWINCH signal handler, instead just poll for the
+  terminal width as needed.  This avoids the "Interrupted System Call"
+  problems that occur on POSIX with all currently released versions of
+  Python.
+  (Andrew Bennetts, #583941)
+
 * Fixed ``AssertionError`` when accessing smart servers running Bazaar
   versions before 1.6.
   (Andrew Bennetts, #528041)
@@ -678,7 +769,7 @@
 * Reset ``siginterrupt`` flag to False every time we handle a signal
   installed with ``set_signal_handler(..., restart_syscall=True)`` (from
   ``bzrlib.osutils``.  Reduces the likelihood of "Interrupted System Call"
-  errors after two window resizes.
+  errors compared to registering ``signal.signal`` directly.
   (Andrew Bennetts)
 
 * Reduce peak memory by one copy of compressed text.

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2010-04-22 10:20:40 +0000
+++ bzrlib/__init__.py	2010-05-27 17:59:18 +0000
@@ -44,7 +44,7 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (2, 2, 0, 'dev', 1)
+version_info = (2, 2, 0, 'beta', 3)
 
 # API compatibility version
 api_minimum_version = (2, 2, 0)

=== modified file 'bzrlib/_readdir_pyx.pyx'
--- bzrlib/_readdir_pyx.pyx	2010-05-21 01:55:34 +0000
+++ bzrlib/_readdir_pyx.pyx	2010-05-21 13:36:51 +0000
@@ -106,15 +106,22 @@
     int closedir(DIR * dir)
     dirent *readdir(DIR *dir)
 
+cdef object _directory
 _directory = 'directory'
+cdef object _chardev
 _chardev = 'chardev'
+cdef object _block
 _block = 'block'
+cdef object _file
 _file = 'file'
+cdef object _fifo
 _fifo = 'fifo'
+cdef object _symlink
 _symlink = 'symlink'
+cdef object _socket
 _socket = 'socket'
+cdef object _unknown
 _unknown = 'unknown'
-_missing = 'missing'
 
 # add a typedef struct dirent dirent to workaround pyrex
 cdef extern from 'readdir.h':
@@ -161,25 +168,12 @@
 
 from bzrlib import osutils
 
+cdef object _safe_utf8
+_safe_utf8 = osutils.safe_utf8
 
 cdef class UTF8DirReader:
     """A dir reader for utf8 file systems."""
 
-    cdef readonly object _safe_utf8
-    cdef _directory, _chardev, _block, _file, _fifo, _symlink
-    cdef _socket, _unknown
-
-    def __init__(self):
-        self._safe_utf8 = osutils.safe_utf8
-        self._directory = _directory
-        self._chardev = _chardev
-        self._block = _block
-        self._file = _file
-        self._fifo = _fifo
-        self._symlink = _symlink
-        self._socket = _socket
-        self._unknown = _unknown
-
     def kind_from_mode(self, int mode):
         """Get the kind of a path from a mode status."""
         return self._kind_from_mode(mode)
@@ -187,25 +181,24 @@
     cdef _kind_from_mode(self, int mode):
         # Files and directories are the most common - check them first.
         if S_ISREG(mode):
-            return self._file
+            return _file
         if S_ISDIR(mode):
-            return self._directory
+            return _directory
         if S_ISCHR(mode):
-            return self._chardev
+            return _chardev
         if S_ISBLK(mode):
-            return self._block
+            return _block
         if S_ISLNK(mode):
-            return self._symlink
+            return _symlink
         if S_ISFIFO(mode):
-            return self._fifo
+            return _fifo
         if S_ISSOCK(mode):
-            return self._socket
-        return self._unknown
+            return _socket
+        return _unknown
 
     def top_prefix_to_starting_dir(self, top, prefix=""):
         """See DirReader.top_prefix_to_starting_dir."""
-        return (self._safe_utf8(prefix), None, None, None,
-            self._safe_utf8(top))
+        return (_safe_utf8(prefix), None, None, None, _safe_utf8(top))
 
     def read_dir(self, prefix, top):
         """Read a single directory from a utf8 file system.

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-05-24 01:05:14 +0000
+++ bzrlib/builtins.py	2010-05-31 21:31:18 +0000
@@ -3145,8 +3145,11 @@
         def get_message(commit_obj):
             """Callback to get commit message"""
             if file:
-                my_message = codecs.open(
-                    file, 'rt', osutils.get_user_encoding()).read()
+                f = codecs.open(file, 'rt', osutils.get_user_encoding())
+                try:
+                    my_message = f.read()
+                finally:
+                    f.close()
             elif message is not None:
                 my_message = message
             else:

=== modified file 'bzrlib/bundle/bundle_data.py'
--- bzrlib/bundle/bundle_data.py	2009-05-06 05:36:28 +0000
+++ bzrlib/bundle/bundle_data.py	2010-05-31 21:31:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -278,7 +278,11 @@
         if rev.revision_id != revision_id:
             raise AssertionError()
         if sha1 != rev.inventory_sha1:
-            open(',,bogus-inv', 'wb').write(s)
+            f = open(',,bogus-inv', 'wb')
+            try:
+                f.write(s)
+            finally:
+                f.close()
             warning('Inventory sha hash mismatch for revision %s. %s'
                     ' != %s' % (revision_id, sha1, rev.inventory_sha1))
 

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2010-05-20 18:23:17 +0000
+++ bzrlib/bzrdir.py	2010-05-25 17:27:52 +0000
@@ -2873,7 +2873,11 @@
             self.revisions[rev_id] = rev
 
     def _load_old_inventory(self, rev_id):
-        old_inv_xml = self.branch.repository.inventory_store.get(rev_id).read()
+        f = self.branch.repository.inventory_store.get(rev_id)
+        try:
+            old_inv_xml = f.read()
+        finally:
+            f.close()
         inv = xml4.serializer_v4.read_inventory_from_string(old_inv_xml)
         inv.revision_id = rev_id
         rev = self.revisions[rev_id]
@@ -2957,8 +2961,11 @@
                 ie.revision = previous_ie.revision
                 return
         if ie.has_text():
-            text = self.branch.repository._text_store.get(ie.text_id)
-            file_lines = text.readlines()
+            f = self.branch.repository._text_store.get(ie.text_id)
+            try:
+                file_lines = f.readlines()
+            finally:
+                f.close()
             w.add_lines(rev_id, previous_revisions, file_lines)
             self.text_count += 1
         else:

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2010-05-11 11:05:49 +0000
+++ bzrlib/commands.py	2010-05-27 21:16:48 +0000
@@ -397,6 +397,12 @@
             will not mangled.
 
     :cvar hooks: An instance of CommandHooks.
+    :ivar __doc__: The help shown by 'bzr help command' for this command.
+        This is set by assigning explicitly to __doc__ so that -OO can
+        be used::
+
+        class Foo(Command):
+            __doc__ = "My help goes here"
     """
     aliases = []
     takes_args = []
@@ -407,8 +413,6 @@
 
     def __init__(self):
         """Construct an instance of this command."""
-        if self.__doc__ == Command.__doc__ or not self.__doc__:
-            raise ValueError("No help message set for %r" % self)
         # List of standard options directly supported
         self.supported_std_options = []
         self._setup_run()
@@ -482,10 +486,8 @@
             message explaining how to obtain full help.
         """
         doc = self.help()
-        if doc is None:
-            raise NotImplementedError(
-                "self.help() returned None -  no detailed help yet for %r" %
-                self.name())
+        if not doc:
+            doc = "No help for this command."
 
         # Extract the summary (purpose) and sections out from the text
         purpose,sections,order = self._get_help_parts(doc)

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2010-05-07 06:35:34 +0000
+++ bzrlib/config.py	2010-05-25 17:27:52 +0000
@@ -477,6 +477,14 @@
     def _get_nickname(self):
         return self.get_user_option('nickname')
 
+    def _write_config_file(self):
+        f = file(self._get_filename(), "wb")
+        try:
+            osutils.copy_ownership_from_path(f.name)
+            self._get_parser().write(f)
+        finally:
+            f.close()
+
 
 class GlobalConfig(IniBasedConfig):
     """The configuration that should be used for a specific location."""
@@ -518,13 +526,6 @@
         self._get_parser().setdefault(section, {})[option] = value
         self._write_config_file()
 
-    def _write_config_file(self):
-        path = self._get_filename()
-        f = open(path, 'wb')
-        osutils.copy_ownership_from_path(path)
-        self._get_parser().write(f)
-        f.close()
-
 
 class LocationConfig(IniBasedConfig):
     """A configuration object that gives the policy for a location."""
@@ -664,7 +665,7 @@
         self._get_parser()[location][option]=value
         # the allowed values of store match the config policies
         self._set_option_policy(location, option, store)
-        self._get_parser().write(file(self._get_filename(), 'wb'))
+        self._write_config_file()
 
 
 class BranchConfig(Config):
@@ -991,7 +992,11 @@
         """Save the config file, only tests should use it for now."""
         conf_dir = os.path.dirname(self._filename)
         ensure_config_dir_exists(conf_dir)
-        self._get_config().write(file(self._filename, 'wb'))
+        f = file(self._filename, 'wb')
+        try:
+            self._get_config().write(f)
+        finally:
+            f.close()
 
     def _set_option(self, section_name, option_name, value):
         """Set an authentication configuration option"""
@@ -1445,7 +1450,11 @@
             return StringIO()
 
     def _get_configobj(self):
-        return ConfigObj(self._get_config_file(), encoding='utf-8')
+        f = self._get_config_file()
+        try:
+            return ConfigObj(f, encoding='utf-8')
+        finally:
+            f.close()
 
     def _set_configobj(self, configobj):
         out_file = StringIO()

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2010-04-30 11:35:43 +0000
+++ bzrlib/diff.py	2010-05-25 17:27:52 +0000
@@ -706,7 +706,7 @@
         """
         def _get_text(tree, file_id, path):
             if file_id is not None:
-                return tree.get_file(file_id, path).readlines()
+                return tree.get_file_lines(file_id, path)
             else:
                 return []
         try:

=== modified file 'bzrlib/hashcache.py'
--- bzrlib/hashcache.py	2009-05-06 05:36:28 +0000
+++ bzrlib/hashcache.py	2010-05-31 21:31:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -289,6 +289,9 @@
 
             self._cache[path] = (sha1, fp)
 
+        # GZ 2009-09-20: Should really use a try/finally block to ensure close
+        inf.close()
+
         self.needs_write = False
 
     def _cutoff_time(self):

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2010-04-30 11:03:59 +0000
+++ bzrlib/help.py	2010-05-26 07:19:50 +0000
@@ -44,9 +44,9 @@
     try:
         topics = indices.search(topic)
         shadowed_terms = []
-        for index, topic in topics[1:]:
+        for index, topic_obj in topics[1:]:
             shadowed_terms.append('%s%s' % (index.prefix,
-                topic.get_help_topic()))
+                topic_obj.get_help_topic()))
         source = topics[0][1]
         outfile.write(source.get_help_text(shadowed_terms))
     except errors.NoHelpTopic:

=== modified file 'bzrlib/help_topics/__init__.py'
--- bzrlib/help_topics/__init__.py	2010-04-30 01:39:46 +0000
+++ bzrlib/help_topics/__init__.py	2010-05-20 11:04:58 +0000
@@ -882,6 +882,8 @@
 def help_as_plain_text(text):
     """Minimal converter of reStructuredText to plain text."""
     import re
+    # Remove the standalone code block marker
+    text = re.sub(r"(?m)^\s*::\n\s*$", "", text)
     lines = text.splitlines()
     result = []
     for line in lines:

=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2010-04-30 11:03:59 +0000
+++ bzrlib/hooks.py	2010-05-26 04:26:59 +0000
@@ -276,9 +276,7 @@
 
   yyy.hooks.install_named_hook("xxx", ...)
 
-See `Using hooks`_ in the User Guide for examples.
-
-.. _Using hooks: ../user-guide/hooks.html
+See :doc:`Using hooks<../user-guide/hooks>` in the User Guide for examples.
 
 The class that contains each hook is given before the hooks it supplies. For
 instance, BranchHooks as the class is the hooks class for

=== modified file 'bzrlib/index.py'
--- bzrlib/index.py	2010-04-14 05:06:53 +0000
+++ bzrlib/index.py	2010-05-25 17:27:52 +0000
@@ -462,6 +462,7 @@
         trailers = 0
         pos = stream.tell()
         lines = stream.read().split('\n')
+        # GZ 2009-09-20: Should really use a try/finally block to ensure close
         stream.close()
         del lines[-1]
         _, _, _, trailers = self._parse_lines(lines, pos)

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2010-05-03 04:08:50 +0000
+++ bzrlib/merge.py	2010-05-25 17:27:52 +0000
@@ -1455,7 +1455,7 @@
     def get_lines(self, tree, file_id):
         """Return the lines in a file, or an empty list."""
         if tree.has_id(file_id):
-            return tree.get_file(file_id).readlines()
+            return tree.get_file_lines(file_id)
         else:
             return []
 

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2010-05-05 04:08:11 +0000
+++ bzrlib/option.py	2010-05-23 18:57:38 +0000
@@ -506,9 +506,6 @@
 # Declare the standard options
 _standard_option('help', short_name='h',
                  help='Show help message.')
-_standard_option('null', short_name='0',
-                 help='Use an ASCII NUL (\\0) separator rather than '
-                      'a newline.')
 _standard_option('usage',
                  help='Show usage message and options.')
 _standard_option('verbose', short_name='v',
@@ -533,6 +530,9 @@
                short_name='m',
                help='Message string.')
 _global_option('no-recurse')
+_global_option('null', short_name='0',
+                 help='Use an ASCII NUL (\\0) separator rather than '
+                      'a newline.')
 _global_option('profile',
                help='Show performance profiling information.')
 _global_option('revision',

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-05-24 01:05:14 +0000
+++ bzrlib/osutils.py	2010-05-31 21:31:18 +0000
@@ -1400,6 +1400,12 @@
 terminal_width() returns None.
 """
 
+# Keep some state so that terminal_width can detect if _terminal_size has
+# returned a different size since the process started.  See docstring and
+# comments of terminal_width for details.
+# _terminal_size_state has 3 possible values: no_data, unchanged, and changed.
+_terminal_size_state = 'no_data'
+_first_terminal_size = None
 
 def terminal_width():
     """Return terminal width.
@@ -1409,20 +1415,34 @@
     The rules are:
     - if BZR_COLUMNS is set, returns its value
     - if there is no controlling terminal, returns None
+    - query the OS, if the queried size has changed since the last query,
+      return its value,
     - if COLUMNS is set, returns its value,
+    - if the OS has a value (even though it's never changed), return its value.
 
     From there, we need to query the OS to get the size of the controlling
     terminal.
 
-    Unices:
+    On Unices we query the OS by:
     - get termios.TIOCGWINSZ
     - if an error occurs or a negative value is obtained, returns None
 
-    Windows:
-    
+    On Windows we query the OS by:
     - win32utils.get_console_size() decides,
     - returns None on error (provided default value)
     """
+    # Note to implementors: if changing the rules for determining the width,
+    # make sure you've considered the behaviour in these cases:
+    #  - M-x shell in emacs, where $COLUMNS is set and TIOCGWINSZ returns 0,0.
+    #  - bzr log | less, in bash, where $COLUMNS not set and TIOCGWINSZ returns
+    #    0,0.
+    #  - (add more interesting cases here, if you find any)
+    # Some programs implement "Use $COLUMNS (if set) until SIGWINCH occurs",
+    # but we don't want to register a signal handler because it is impossible
+    # to do so without risking EINTR errors in Python <= 2.6.5 (see
+    # <http://bugs.python.org/issue8354>).  Instead we check TIOCGWINSZ every
+    # time so we can notice if the reported size has changed, which should have
+    # a similar effect.
 
     # If BZR_COLUMNS is set, take it, user is always right
     try:
@@ -1431,24 +1451,39 @@
         pass
 
     isatty = getattr(sys.stdout, 'isatty', None)
-    if  isatty is None or not isatty():
+    if isatty is None or not isatty():
         # Don't guess, setting BZR_COLUMNS is the recommended way to override.
         return None
 
-    # If COLUMNS is set, take it, the terminal knows better (even inside a
-    # given terminal, the application can decide to set COLUMNS to a lower
-    # value (splitted screen) or a bigger value (scroll bars))
+    # Query the OS
+    width, height = os_size = _terminal_size(None, None)
+    global _first_terminal_size, _terminal_size_state
+    if _terminal_size_state == 'no_data':
+        _first_terminal_size = os_size
+        _terminal_size_state = 'unchanged'
+    elif (_terminal_size_state == 'unchanged' and
+          _first_terminal_size != os_size):
+        _terminal_size_state = 'changed'
+
+    # If the OS claims to know how wide the terminal is, and this value has
+    # ever changed, use that.
+    if _terminal_size_state == 'changed':
+        if width is not None and width > 0:
+            return width
+
+    # If COLUMNS is set, use it.
     try:
         return int(os.environ['COLUMNS'])
     except (KeyError, ValueError):
         pass
 
-    width, height = _terminal_size(None, None)
-    if width <= 0:
-        # Consider invalid values as meaning no width
-        return None
+    # Finally, use an unchanged size from the OS, if we have one.
+    if _terminal_size_state == 'unchanged':
+        if width is not None and width > 0:
+            return width
 
-    return width
+    # The width could not be determined.
+    return None
 
 
 def _win32_terminal_size(width, height):
@@ -1481,31 +1516,6 @@
     _terminal_size = _ioctl_terminal_size
 
 
-def _terminal_size_changed(signum, frame):
-    """Set COLUMNS upon receiving a SIGnal for WINdow size CHange."""
-    width, height = _terminal_size(None, None)
-    if width is not None:
-        os.environ['COLUMNS'] = str(width)
-
-
-_registered_sigwinch = False
-def watch_sigwinch():
-    """Register for SIGWINCH, once and only once.
-
-    Do nothing if the signal module is not available.
-    """
-    global _registered_sigwinch
-    if not _registered_sigwinch:
-        try:
-            import signal
-            if getattr(signal, "SIGWINCH", None) is not None:
-                set_signal_handler(signal.SIGWINCH, _terminal_size_changed)
-        except ImportError:
-            # python doesn't provide signal support, nothing we can do about it
-            pass
-        _registered_sigwinch = True
-
-
 def supports_executable():
     return sys.platform != "win32"
 
@@ -2078,9 +2088,11 @@
     base = dirname(bzrlib.__file__)
     if getattr(sys, 'frozen', None):    # bzr.exe
         base = abspath(pathjoin(base, '..', '..'))
-    filename = pathjoin(base, resource_relpath)
-    return open(filename, 'rU').read()
-
+    f = file(pathjoin(base, resource_relpath), "rU")
+    try:
+        return f.read()
+    finally:
+        f.close()
 
 def file_kind_from_stat_mode_thunk(mode):
     global file_kind_from_stat_mode

=== modified file 'bzrlib/plugins/bash_completion/README.txt'
--- bzrlib/plugins/bash_completion/README.txt	2010-04-22 06:43:53 +0000
+++ bzrlib/plugins/bash_completion/README.txt	2010-05-22 11:16:04 +0000
@@ -17,11 +17,11 @@
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-=====================================
-bzr bash-completion script and plugin
-=====================================
+==========================
+bzr bash-completion plugin
+==========================
 
-This script generates a shell function which can be used by bash to
+This plugin generates a shell function which can be used by bash to
 automatically complete the currently typed command when the user
 presses the completion key (usually tab).
 
@@ -32,65 +32,25 @@
 
 .. contents::
 
-----------
-Installing
-----------
-
-You only need to do this if you want to use the script as a bzr
-plugin.  Otherwise simply grab the bashcomp.py and place it wherever
-you want.
-
-Installing from bzr repository
-------------------------------
-
-To check out the current code from launchpad, use the following commands::
-
-  mkdir -p ~/.bazaar/plugins
-  cd ~/.bazaar/plugins
-  bzr checkout lp:bzr-bash-completion bash_completion
-
-To update such an installation, execute this command::
-
-  bzr update ~/.bazaar/plugins/bash_completion
-
-Installing using easy_install
------------------------------
-
-The following command should install the latest release of the plugin
-on your system::
-
-  easy_install bzr-bash-completion
-
-To use this method, you need to have `Easy Install`_ installed and
-also have write access to the required directories. So maybe you
-should execute this command as root or through sudo_. Or you want to
-`install to a different location`_.
-
-.. _Easy Install: http://peak.telecommunity.com/DevCenter/EasyInstall
-.. _sudo: http://linux.die.net/man/8/sudo
-.. _install to a different location:
-   http://peak.telecommunity.com/DevCenter/EasyInstall#non-root-installation
-
-Installing from tarball
------------------------
-
-If you have grabbed a source code tarball, or want to install from a
-bzr checkout in a different place than your bazaar plugins directory,
-then you should use the ``setup.py`` script shipped with the code::
-
-  ./setup.py install
-
-If you want to install the plugin only for your own user account, you
-might wish to pass the option ``--user`` or ``--home=$HOME`` to that
-command. For further information please read the manuals of distutils_
-as well as setuptools_ or distribute_, whatever is available on your
-system, or have a look at the command line help::
-
-  ./setup.py install --help
-
-.. _distutils: http://docs.python.org/install/index.html
-.. _setuptools: http://peak.telecommunity.com/DevCenter/setuptools#what-your-users-should-know
-.. _distribute: http://packages.python.org/distribute/setuptools.html#what-your-users-should-know
+-------------------------------
+Bundled and standalone versions
+-------------------------------
+
+This plugin has been merged_ into the main source tree of Bazaar.
+Starting with the bzr 2.3 series, a common bzr installation will
+include this plugin.
+
+There is still a standalone version available. It makes the plugin
+available for users of older bzr versions. When using both versions,
+local configuration might determine which version actually gets used,
+and some installations might even overwrite one another, so don't use
+the standalone version if you have the bundled one, unless you know
+what you are doing. Some effort will be made to keep the two versions
+reasonably in sync for some time yet.
+
+This text here documents the bundled version.
+
+.. _merged: http://bazaar.launchpad.net/~bzr-pqm/bzr/bzr.dev/revision/5240
 
 -----
 Using
@@ -114,42 +74,24 @@
 To avoid this problem, you can delay the generation of the completion
 function until you actually need it.
 
-To do so, source the file ``lazy.sh`` shipped with this package from
-your ``~/.bashrc`` file or add it to your ``~/.bash_completion`` if
+To do so, source the file ``contrib/bash/bzr`` shipped with the bzr
+source distribution from your ``~/.bashrc`` file
+or add it to your ``~/.bash_completion`` if
 your setup uses such a file. On a system-wide installation, the
 directory ``/usr/share/bash-completion/`` might contain such bash
 completion scripts.
 
-If you installed bzr-bash-completion from the repository or a source
-tarball, you find the ``lazy.sh`` script in the root of the source
-tree. If you installed the plugin using easy_install, you should grab
-the script manually from the bzr repository, e.g. through the bazaar
-web interface on launchpad.
-
 Note that the full completion function is generated only once per
 shell session. If you update your bzr installation or change the set
 of installed plugins, then you might wish to regenerate the completion
 function manually as described above in order for completion to take
 these changes into account.
 
-Using as a script
------------------
-
-As an alternative, if bzrlib is available to python scripts, the
-following invocation should yield the same results without requiring
-you to add a plugin::
-
-  eval "`./bashcomp.py`"
-
-This approach might have some issues, though, and provides less
-options than the bzr plugin. Therefore if you have the choice, go for
-the plugin setup.
-
 --------------
 Design concept
 --------------
 
-The plugin (or script) is designed to generate a completion function
+The plugin is designed to generate a completion function
 containing all the required information about the possible
 completions. This is usually only done once when bash
 initializes. After that, no more invocations of bzr are required. This
@@ -165,14 +107,12 @@
 
 As this is built upon a bash completion script originally included in
 the bzr source tree, and as the bzr sources are covered by the GPL 2,
-this script here is licensed under these same terms.
+this plugin here is licensed under these same terms.
 
 If you require a more liberal license, you'll have to contact all
 those who contributed code to this plugin, be it for bash or for
 python.
 
-.. cut long_description here
-
 -------
 History
 -------
@@ -181,15 +121,17 @@
 static completion function of very limited scope distributed together
 with bzr.
 
+A version of it was merged into the bzr source tree in May 2010.
+
 ----------
 References
 ----------
 
-Plugin homepages
+Bazaar homepage
+  | http://bazaar.canonical.com/
+Standalone plugin homepages
   | https://launchpad.net/bzr-bash-completion
   | http://pypi.python.org/pypi/bzr-bash-completion
-Bazaar homepage
-  | http://bazaar.canonical.com/
 
 
 

=== modified file 'bzrlib/plugins/bash_completion/bashcomp.py'
--- bzrlib/plugins/bash_completion/bashcomp.py	2010-05-05 08:08:48 +0000
+++ bzrlib/plugins/bash_completion/bashcomp.py	2010-05-21 06:17:55 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 from bzrlib import (
+    cmdline,
     commands,
     config,
     help_topics,
@@ -293,7 +294,7 @@
 
     def aliases(self):
         for alias, expansion in config.GlobalConfig().get_aliases().iteritems():
-            for token in commands.shlex_split_unicode(expansion):
+            for token in cmdline.split(expansion):
                 if not token.startswith("-"):
                     self.user_aliases.setdefault(token, set()).add(alias)
                     break

=== modified file 'bzrlib/plugins/bash_completion/tests/test_bashcomp.py'
--- bzrlib/plugins/bash_completion/tests/test_bashcomp.py	2010-05-04 19:30:44 +0000
+++ bzrlib/plugins/bash_completion/tests/test_bashcomp.py	2010-05-25 11:20:16 +0000
@@ -22,35 +22,10 @@
 import subprocess
 
 
-class _BashFeature(tests.Feature):
-    """Feature testing whether a bash executable is available."""
-
-    bash_paths = ['/bin/bash', '/usr/bin/bash']
-
-    def __init__(self):
-        super(_BashFeature, self).__init__()
-        self.bash_path = None
-
-    def available(self):
-        if self.bash_path is not None:
-            return self.bash_path is not False
-        for path in self.bash_paths:
-            if os.access(path, os.X_OK):
-                self.bash_path = path
-                return True
-        self.bash_path = False
-        return False
-
-    def feature_name(self):
-        return 'bash'
-
-BashFeature = _BashFeature()
-
-
 class BashCompletionMixin(object):
     """Component for testing execution of a bash completion script."""
 
-    _test_needs_features = [BashFeature]
+    _test_needs_features = [tests.features.bash_feature]
 
     def complete(self, words, cword=-1):
         """Perform a bash completion.
@@ -60,7 +35,8 @@
         """
         if self.script is None:
             self.script = self.get_script()
-        proc = subprocess.Popen([BashFeature.bash_path, '--noprofile'],
+        proc = subprocess.Popen([tests.features.bash_feature.path,
+                                 '--noprofile'],
                                 stdin=subprocess.PIPE,
                                 stdout=subprocess.PIPE,
                                 stderr=subprocess.PIPE)
@@ -187,6 +163,7 @@
         return s.replace("$(bzr ", "$('%s' " % self.get_bzr_path())
 
     def test_revspec_tag_all(self):
+        self.requireFeature(tests.features.sed_feature)
         wt = self.make_branch_and_tree('.', format='dirstate-tags')
         wt.branch.tags.set_tag('tag1', 'null:')
         wt.branch.tags.set_tag('tag2', 'null:')
@@ -195,6 +172,7 @@
         self.assertCompletionEquals('tag1', 'tag2', '3tag')
 
     def test_revspec_tag_prefix(self):
+        self.requireFeature(tests.features.sed_feature)
         wt = self.make_branch_and_tree('.', format='dirstate-tags')
         wt.branch.tags.set_tag('tag1', 'null:')
         wt.branch.tags.set_tag('tag2', 'null:')

=== modified file 'bzrlib/plugins/launchpad/__init__.py'
--- bzrlib/plugins/launchpad/__init__.py	2010-04-02 19:12:58 +0000
+++ bzrlib/plugins/launchpad/__init__.py	2010-05-21 04:27:11 +0000
@@ -310,6 +310,8 @@
                             help='Propose the merge on staging.'),
                      Option('message', short_name='m', type=unicode,
                             help='Commit message.'),
+                     Option('approve',
+                            help='Mark the proposal as approved immediately.'),
                      ListOption('review', short_name='R', type=unicode,
                             help='Requested reviewer and optional type.')]
 
@@ -318,7 +320,7 @@
     aliases = ['lp-submit', 'lp-propose']
 
     def run(self, submit_branch=None, review=None, staging=False,
-            message=None):
+            message=None, approve=False):
         from bzrlib.plugins.launchpad import lp_propose
         tree, branch, relpath = bzrdir.BzrDir.open_containing_tree_or_branch(
             '.')
@@ -338,7 +340,7 @@
         else:
             target = _mod_branch.Branch.open(submit_branch)
         proposer = lp_propose.Proposer(tree, branch, target, message,
-                                       reviews, staging)
+                                       reviews, staging, approve=approve)
         proposer.check_proposal()
         proposer.create_proposal()
 

=== modified file 'bzrlib/plugins/launchpad/lp_propose.py'
--- bzrlib/plugins/launchpad/lp_propose.py	2010-05-21 07:17:13 +0000
+++ bzrlib/plugins/launchpad/lp_propose.py	2010-05-21 11:01:38 +0000
@@ -55,7 +55,7 @@
     hooks = ProposeMergeHooks()
 
     def __init__(self, tree, source_branch, target_branch, message, reviews,
-                 staging=False):
+                 staging=False, approve=False):
         """Constructor.
 
         :param tree: The working tree for the source branch.
@@ -65,6 +65,10 @@
         :param reviews: A list of tuples of reviewer, review type.
         :param staging: If True, propose the merge against staging instead of
             production.
+        :param approve: If True, mark the new proposal as approved immediately.
+            This is useful when a project permits some things to be approved
+            by the submitter (e.g. merges between release and deployment
+            branches).
         """
         self.tree = tree
         if staging:
@@ -81,6 +85,7 @@
             self.target_branch = lp_api.LaunchpadBranch.from_bzr(
                 self.launchpad, target_branch)
         self.commit_message = message
+        # XXX: this is where bug lp:583638 could be tackled.
         if reviews == []:
             target_reviewer = self.target_branch.lp.reviewer
             if target_reviewer is None:
@@ -90,6 +95,7 @@
             self.reviews = [(self.launchpad.people[reviewer], review_type)
                             for reviewer, review_type in
                             reviews]
+        self.approve = approve
 
     def get_comment(self, prerequisite_branch):
         """Determine the initial comment for the merge proposal."""
@@ -160,6 +166,24 @@
                  'prerequisite_branch': prerequisite_branch})
         return prerequisite_branch
 
+    def call_webservice(self, call, *args, **kwargs):
+        """Make a call to the webservice, wrapping failures.
+        
+        :param call: The call to make.
+        :param *args: *args for the call.
+        :param **kwargs: **kwargs for the call.
+        :return: The result of calling call(*args, *kwargs).
+        """
+        try:
+            return call(*args, **kwargs)
+        except restful_errors.HTTPError, e:
+            error_lines = []
+            for line in e.content.splitlines():
+                if line.startswith('Traceback (most recent call last):'):
+                    break
+                error_lines.append(line)
+            raise Exception(''.join(error_lines))
+
     def create_proposal(self):
         """Perform the submission."""
         prerequisite_branch = self._get_prerequisite_branch()
@@ -175,22 +199,16 @@
             review_types.append(review_type)
             reviewers.append(reviewer.self_link)
         initial_comment = self.get_comment(prerequisite_branch)
-        try:
-            mp = self.source_branch.lp.createMergeProposal(
-                target_branch=self.target_branch.lp,
-                prerequisite_branch=prereq,
-                initial_comment=initial_comment,
-                commit_message=self.commit_message, reviewers=reviewers,
-                review_types=review_types)
-        except restful_errors.HTTPError, e:
-            error_lines = []
-            for line in e.content.splitlines():
-                if line.startswith('Traceback (most recent call last):'):
-                    break
-                error_lines.append(line)
-            raise Exception(''.join(error_lines))
-        else:
-            webbrowser.open(canonical_url(mp))
+        mp = self.call_webservice(
+            self.source_branch.lp.createMergeProposal,
+            target_branch=self.target_branch.lp,
+            prerequisite_branch=prereq,
+            initial_comment=initial_comment,
+            commit_message=self.commit_message, reviewers=reviewers,
+            review_types=review_types)
+        if self.approve:
+            self.call_webservice(mp.setStatus, status='Approved')
+        webbrowser.open(canonical_url(mp))
 
 
 def modified_files(old_tree, new_tree):

=== modified file 'bzrlib/store/text.py'
--- bzrlib/store/text.py	2009-03-23 14:59:43 +0000
+++ bzrlib/store/text.py	2010-05-31 21:31:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -118,7 +118,9 @@
         # so buffer them in a StringIO instead
         if getattr(f, 'tell', None) is not None:
             return gzip.GzipFile(mode='rb', fileobj=f)
-        else:
+        try:
             from cStringIO import StringIO
             sio = StringIO(f.read())
             return gzip.GzipFile(mode='rb', fileobj=sio)
+        finally:
+            f.close()

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-05-25 07:30:27 +0000
+++ bzrlib/tests/__init__.py	2010-05-31 21:31:18 +0000
@@ -29,7 +29,7 @@
 
 import atexit
 import codecs
-from copy import copy
+import copy
 from cStringIO import StringIO
 import difflib
 import doctest
@@ -37,12 +37,12 @@
 import logging
 import math
 import os
-from pprint import pformat
+import pprint
 import random
 import re
 import shlex
 import stat
-from subprocess import Popen, PIPE, STDOUT
+import subprocess
 import sys
 import tempfile
 import threading
@@ -74,6 +74,7 @@
     ui,
     urlutils,
     registry,
+    transport as _mod_transport,
     workingtree,
     )
 import bzrlib.branch
@@ -103,11 +104,9 @@
     )
 import bzrlib.trace
 from bzrlib.transport import (
-    get_transport,
     memory,
     pathfilter,
     )
-import bzrlib.transport
 from bzrlib.trace import mutter, note
 from bzrlib.tests import (
     test_server,
@@ -940,7 +939,7 @@
 
     def permit_dir(self, name):
         """Permit a directory to be used by this test. See permit_url."""
-        name_transport = get_transport(name)
+        name_transport = _mod_transport.get_transport(name)
         self.permit_url(name)
         self.permit_url(name_transport.base)
 
@@ -1025,7 +1024,7 @@
         self.addCleanup(transport_server.stop_server)
         # Obtain a real transport because if the server supplies a password, it
         # will be hidden from the base on the client side.
-        t = get_transport(transport_server.get_url())
+        t = _mod_transport.get_transport(transport_server.get_url())
         # Some transport servers effectively chroot the backing transport;
         # others like SFTPServer don't - users of the transport can walk up the
         # transport to read the entire backing transport. This wouldn't matter
@@ -1092,7 +1091,7 @@
             message += '\n'
         raise AssertionError("%snot equal:\na = %s\nb = %s\n"
             % (message,
-               pformat(a), pformat(b)))
+               pprint.pformat(a), pprint.pformat(b)))
 
     assertEquals = assertEqual
 
@@ -1983,7 +1982,9 @@
             if not allow_plugins:
                 command.append('--no-plugins')
             command.extend(process_args)
-            process = self._popen(command, stdin=PIPE, stdout=PIPE, stderr=PIPE)
+            process = self._popen(command, stdin=subprocess.PIPE,
+                                  stdout=subprocess.PIPE,
+                                  stderr=subprocess.PIPE)
         finally:
             restore_environment()
             if cwd is not None:
@@ -1997,7 +1998,7 @@
         Allows tests to override this method to intercept the calls made to
         Popen for introspection.
         """
-        return Popen(*args, **kwargs)
+        return subprocess.Popen(*args, **kwargs)
 
     def get_source_path(self):
         """Return the path of the directory containing bzrlib."""
@@ -2183,7 +2184,7 @@
 
         :param relpath: a path relative to the base url.
         """
-        t = get_transport(self.get_url(relpath))
+        t = _mod_transport.get_transport(self.get_url(relpath))
         self.assertFalse(t.is_readonly())
         return t
 
@@ -2195,7 +2196,7 @@
 
         :param relpath: a path relative to the base url.
         """
-        t = get_transport(self.get_readonly_url(relpath))
+        t = _mod_transport.get_transport(self.get_readonly_url(relpath))
         self.assertTrue(t.is_readonly())
         return t
 
@@ -2331,7 +2332,7 @@
         propagating. This method ensures than a test did not leaked.
         """
         root = TestCaseWithMemoryTransport.TEST_ROOT
-        self.permit_url(get_transport(root).base)
+        self.permit_url(_mod_transport.get_transport(root).base)
         wt = workingtree.WorkingTree.open(root)
         last_rev = wt.last_revision()
         if last_rev != 'null:':
@@ -2382,7 +2383,7 @@
             # might be a relative or absolute path
             maybe_a_url = self.get_url(relpath)
             segments = maybe_a_url.rsplit('/', 1)
-            t = get_transport(maybe_a_url)
+            t = _mod_transport.get_transport(maybe_a_url)
             if len(segments) > 1 and segments[-1] not in ('', '.'):
                 t.ensure_base()
             if format is None:
@@ -2408,7 +2409,8 @@
     def make_smart_server(self, path):
         smart_server = test_server.SmartTCPServer_for_testing()
         self.start_server(smart_server, self.get_server())
-        remote_transport = get_transport(smart_server.get_url()).clone(path)
+        remote_transport = _mod_transport.get_transport(smart_server.get_url()
+                                                   ).clone(path)
         return remote_transport
 
     def make_branch_and_memory_tree(self, relpath, format=None):
@@ -2479,7 +2481,11 @@
 
     def check_file_contents(self, filename, expect):
         self.log("check contents of file %s" % filename)
-        contents = file(filename, 'r').read()
+        f = file(filename)
+        try:
+            contents = f.read()
+        finally:
+            f.close()
         if contents != expect:
             self.log("expected: %r" % expect)
             self.log("actually: %r" % contents)
@@ -2559,7 +2565,7 @@
                 "a list or a tuple. Got %r instead" % (shape,))
         # It's OK to just create them using forward slashes on windows.
         if transport is None or transport.is_readonly():
-            transport = get_transport(".")
+            transport = _mod_transport.get_transport(".")
         for name in shape:
             self.assertIsInstance(name, basestring)
             if name[-1] == '/':
@@ -3307,10 +3313,12 @@
                 '--subunit']
             if '--no-plugins' in sys.argv:
                 argv.append('--no-plugins')
-            # stderr=STDOUT would be ideal, but until we prevent noise on
-            # stderr it can interrupt the subunit protocol.
-            process = Popen(argv, stdin=PIPE, stdout=PIPE, stderr=PIPE,
-                bufsize=1)
+            # stderr=subrocess.STDOUT would be ideal, but until we prevent
+            # noise on stderr it can interrupt the subunit protocol.
+            process = subrocess.Popen(argv, stdin=subrocess.PIPE,
+                                      stdout=subrocess.PIPE,
+                                      stderr=subrocess.PIPE,
+                                      bufsize=1)
             test = TestInSubprocess(process, test_list_file_name)
             result.append(test)
         except:
@@ -4034,7 +4042,7 @@
     :param new_id: The id to assign to it.
     :return: The new test.
     """
-    new_test = copy(test)
+    new_test = copy.copy(test)
     new_test.id = lambda: new_id
     return new_test
 

=== modified file 'bzrlib/tests/features.py'
--- bzrlib/tests/features.py	2010-05-21 06:14:50 +0000
+++ bzrlib/tests/features.py	2010-05-25 21:30:52 +0000
@@ -80,3 +80,36 @@
 
 chown_feature = _ChownFeature()
 
+
+class ExecutableFeature(tests.Feature):
+    """Feature testing whether an executable of a given name is on the PATH."""
+
+    def __init__(self, name):
+        super(ExecutableFeature, self).__init__()
+        self.name = name
+        self._path = None
+
+    @property
+    def path(self):
+        # This is a property, so accessing path ensures _probe was called
+        self.available()
+        return self._path
+
+    def _probe(self):
+        path = os.environ.get('PATH')
+        if path is None:
+            return False
+        for d in path.split(os.pathsep):
+            if d:
+                f = os.path.join(d, self.name)
+                if os.access(f, os.X_OK):
+                    self._path = f
+                    return True
+        return False
+
+    def feature_name(self):
+        return '%s executable' % self.name
+
+
+bash_feature = ExecutableFeature('bash')
+sed_feature = ExecutableFeature('sed')

=== modified file 'bzrlib/tests/test_commands.py'
--- bzrlib/tests/test_commands.py	2010-05-11 11:05:49 +0000
+++ bzrlib/tests/test_commands.py	2010-05-27 21:16:48 +0000
@@ -16,6 +16,7 @@
 
 from cStringIO import StringIO
 import errno
+import inspect
 import sys
 
 from bzrlib import (
@@ -33,6 +34,17 @@
 
 class TestCommands(tests.TestCase):
 
+    def test_all_commands_have_help(self):
+        commands._register_builtin_commands()
+        commands_without_help = set()
+        base_doc = inspect.getdoc(commands.Command)
+        for cmd_name in commands.all_command_names():
+            cmd = commands.get_cmd_object(cmd_name)
+            cmd_help = cmd.help()
+            if not cmd_help or cmd_help == base_doc:
+                commands_without_help.append(cmd_name)
+        self.assertLength(0, commands_without_help)
+
     def test_display_command(self):
         """EPIPE message is selectively suppressed"""
         def pipe_thrower():
@@ -79,11 +91,6 @@
         c = self.get_command([option.Option('foo', hidden=False)])
         self.assertContainsRe(c.get_help_text(), '--foo')
 
-    def test_no_help_init_failure(self):
-        class cmd_foo(commands.Command):
-            pass
-        self.assertRaises(ValueError, cmd_foo)
-
 
 class TestGetAlias(tests.TestCase):
 

=== modified file 'bzrlib/tests/test_help.py'
--- bzrlib/tests/test_help.py	2010-05-07 04:25:37 +0000
+++ bzrlib/tests/test_help.py	2010-05-24 05:50:53 +0000
@@ -112,6 +112,12 @@
                 Example 2::
 
                     cmd arg2
+
+                A code block follows.
+
+                ::
+
+                    bzr Demo something
             """
         cmd = cmd_Demo()
         helptext = cmd.get_help_text()
@@ -122,7 +128,6 @@
             '\n'
             'Options:\n'
             '  --usage        Show usage message and options.\n'
-            '  -0, --null     Use an ASCII NUL (\\0) separator rather than a newline.\n'
             '  -v, --verbose  Display more information.\n'
             '  -q, --quiet    Only display errors and warnings.\n'
             '  -h, --help     Show help message.\n'
@@ -135,6 +140,10 @@
             '    Example 2:\n'
             '\n'
             '        cmd arg2\n'
+            '\n'
+            '    A code block follows.\n'
+            '\n'
+            '        bzr Demo something\n'
             '\n')
         helptext = cmd.get_help_text(plain=False)
         self.assertEquals(helptext,
@@ -143,7 +152,6 @@
             '\n'
             ':Options:\n'
             '  --usage        Show usage message and options.\n'
-            '  -0, --null     Use an ASCII NUL (\\0) separator rather than a newline.\n'
             '  -v, --verbose  Display more information.\n'
             '  -q, --quiet    Only display errors and warnings.\n'
             '  -h, --help     Show help message.\n'
@@ -156,6 +164,12 @@
             '    Example 2::\n'
             '\n'
             '        cmd arg2\n'
+            '\n'
+            '    A code block follows.\n'
+            '\n'
+            '    ::\n'
+            '\n'
+            '        bzr Demo something\n'
             '\n')
 
     def test_concise_help_text(self):
@@ -179,7 +193,6 @@
             '\n'
             'Options:\n'
             '  --usage        Show usage message and options.\n'
-            '  -0, --null     Use an ASCII NUL (\\0) separator rather than a newline.\n'
             '  -v, --verbose  Display more information.\n'
             '  -q, --quiet    Only display errors and warnings.\n'
             '  -h, --help     Show help message.\n'
@@ -199,7 +212,6 @@
             '\n'
             'Options:\n'
             '  --usage        Show usage message and options.\n'
-            '  -0, --null     Use an ASCII NUL (\\0) separator rather than a newline.\n'
             '  -v, --verbose  Display more information.\n'
             '  -q, --quiet    Only display errors and warnings.\n'
             '  -h, --help     Show help message.\n'
@@ -234,7 +246,6 @@
             '\n'
             'Options:\n'
             '  --usage        Show usage message and options.\n'
-            '  -0, --null     Use an ASCII NUL (\\0) separator rather than a newline.\n'
             '  -v, --verbose  Display more information.\n'
             '  -q, --quiet    Only display errors and warnings.\n'
             '  -h, --help     Show help message.\n'
@@ -278,7 +289,6 @@
             '\n'
             'Options:\n'
             '  --usage        Show usage message and options.\n'
-            '  -0, --null     Use an ASCII NUL (\\0) separator rather than a newline.\n'
             '  -v, --verbose  Display more information.\n'
             '  -q, --quiet    Only display errors and warnings.\n'
             '  -h, --help     Show help message.\n'

=== modified file 'bzrlib/tests/test_import_tariff.py'
--- bzrlib/tests/test_import_tariff.py	2010-05-20 18:23:17 +0000
+++ bzrlib/tests/test_import_tariff.py	2010-05-31 01:28:29 +0000
@@ -96,6 +96,7 @@
             'bzrlib.remote',
             'bzrlib.sign_my_commits',
             'bzrlib.smart',
+            'kerberos',
             'smtplib',
             'tarfile',
             ])

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2010-05-20 18:23:17 +0000
+++ bzrlib/tests/test_osutils.py	2010-05-27 17:59:18 +0000
@@ -1910,6 +1910,18 @@
 
 class TestTerminalWidth(tests.TestCase):
 
+    def setUp(self):
+        tests.TestCase.setUp(self)
+        self._orig_terminal_size_state = osutils._terminal_size_state
+        self._orig_first_terminal_size = osutils._first_terminal_size
+        self.addCleanup(self.restore_osutils_globals)
+        osutils._terminal_size_state = 'no_data'
+        osutils._first_terminal_size = None
+
+    def restore_osutils_globals(self):
+        osutils._terminal_size_state = self._orig_terminal_size_state
+        osutils._first_terminal_size = self._orig_first_terminal_size
+        
     def replace_stdout(self, new):
         self.overrideAttr(sys, 'stdout', new)
 

=== modified file 'bzrlib/tests/test_urlutils.py'
--- bzrlib/tests/test_urlutils.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_urlutils.py	2010-05-27 22:10:42 +0000
@@ -270,6 +270,51 @@
         self.assertRaises(InvalidURLJoin, urlutils.joinpath, '/', '..')
         self.assertRaises(InvalidURLJoin, urlutils.joinpath, '/', '/..')
 
+    def test_join_segment_parameters_raw(self):
+        join_segment_parameters_raw = urlutils.join_segment_parameters_raw
+        self.assertEquals("/somedir/path", 
+            join_segment_parameters_raw("/somedir/path"))
+        self.assertEquals("/somedir/path,rawdata", 
+            join_segment_parameters_raw("/somedir/path", "rawdata"))
+        self.assertRaises(InvalidURLJoin,
+            join_segment_parameters_raw, "/somedir/path",
+                "rawdata1,rawdata2,rawdata3")
+        self.assertEquals("/somedir/path,bla,bar",
+            join_segment_parameters_raw("/somedir/path", "bla", "bar"))
+        self.assertEquals("/somedir,exist=some/path,bla,bar",
+            join_segment_parameters_raw("/somedir,exist=some/path",
+                "bla", "bar"))
+        self.assertRaises(TypeError, join_segment_parameters_raw, 
+            "/somepath", 42)
+
+    def test_join_segment_parameters(self):
+        join_segment_parameters = urlutils.join_segment_parameters
+        self.assertEquals("/somedir/path", 
+            join_segment_parameters("/somedir/path", {}))
+        self.assertEquals("/somedir/path,key1=val1", 
+            join_segment_parameters("/somedir/path", {"key1": "val1"}))
+        self.assertRaises(InvalidURLJoin,
+            join_segment_parameters, "/somedir/path",
+            {"branch": "brr,brr,brr"})
+        self.assertRaises(InvalidURLJoin,
+            join_segment_parameters, "/somedir/path", {"key1=val1": "val2"})
+        self.assertEquals("/somedir/path,key1=val1,key2=val2",
+            join_segment_parameters("/somedir/path", {
+                "key1": "val1", "key2": "val2"}))
+        self.assertEquals("/somedir/path,key1=val1,key2=val2",
+            join_segment_parameters("/somedir/path,key1=val1", {
+                "key2": "val2"}))
+        self.assertEquals("/somedir/path,key1=val2",
+            join_segment_parameters("/somedir/path,key1=val1", {
+                "key1": "val2"}))
+        self.assertEquals("/somedir,exist=some/path,key1=val1",
+            join_segment_parameters("/somedir,exist=some/path",
+                {"key1": "val1"}))
+        self.assertEquals("/,key1=val1,key2=val2",
+            join_segment_parameters("/,key1=val1", {"key2": "val2"}))
+        self.assertRaises(TypeError,
+            join_segment_parameters, "/,key1=val1", {"foo": 42})
+
     def test_function_type(self):
         if sys.platform == 'win32':
             self.assertEqual(urlutils._win32_local_path_to_url, urlutils.local_path_to_url)
@@ -412,6 +457,53 @@
         self.assertEqual(('path/..', 'foo'), split('path/../foo'))
         self.assertEqual(('../path', 'foo'), split('../path/foo'))
 
+    def test_split_segment_parameters_raw(self):
+        split_segment_parameters_raw = urlutils.split_segment_parameters_raw
+        self.assertEquals(("/some/path", []),
+            split_segment_parameters_raw("/some/path"))
+        self.assertEquals(("/some/path", ["tip"]),
+            split_segment_parameters_raw("/some/path,tip"))
+        self.assertEquals(("/some,dir/path", ["tip"]),
+            split_segment_parameters_raw("/some,dir/path,tip"))
+        self.assertEquals(("/somedir/path", ["heads%2Ftip"]),
+            split_segment_parameters_raw("/somedir/path,heads%2Ftip"))
+        self.assertEquals(("/somedir/path", ["heads%2Ftip", "bar"]),
+            split_segment_parameters_raw("/somedir/path,heads%2Ftip,bar"))
+        self.assertEquals(("/", ["key1=val1"]),
+            split_segment_parameters_raw(",key1=val1"))
+        self.assertEquals(("foo/", ["key1=val1"]),
+            split_segment_parameters_raw("foo/,key1=val1"))
+        self.assertEquals(("foo/base,la=bla/other/elements", []),
+            split_segment_parameters_raw("foo/base,la=bla/other/elements"))
+        self.assertEquals(("foo/base,la=bla/other/elements", ["a=b"]),
+            split_segment_parameters_raw("foo/base,la=bla/other/elements,a=b"))
+
+    def test_split_segment_parameters(self):
+        split_segment_parameters = urlutils.split_segment_parameters
+        self.assertEquals(("/some/path", {}),
+            split_segment_parameters("/some/path"))
+        self.assertEquals(("/some/path", {"branch": "tip"}),
+            split_segment_parameters("/some/path,branch=tip"))
+        self.assertEquals(("/some,dir/path", {"branch": "tip"}),
+            split_segment_parameters("/some,dir/path,branch=tip"))
+        self.assertEquals(("/somedir/path", {"ref": "heads%2Ftip"}),
+            split_segment_parameters("/somedir/path,ref=heads%2Ftip"))
+        self.assertEquals(("/somedir/path",
+            {"ref": "heads%2Ftip", "key1": "val1"}),
+            split_segment_parameters(
+                "/somedir/path,ref=heads%2Ftip,key1=val1"))
+        self.assertEquals(("/somedir/path", {"ref": "heads%2F=tip"}),
+            split_segment_parameters("/somedir/path,ref=heads%2F=tip"))
+        self.assertEquals(("/", {"key1": "val1"}),
+            split_segment_parameters(",key1=val1"))
+        self.assertEquals(("foo/", {"key1": "val1"}),
+            split_segment_parameters("foo/,key1=val1"))
+        self.assertEquals(("foo/base,key1=val1/other/elements", {}),
+            split_segment_parameters("foo/base,key1=val1/other/elements"))
+        self.assertEquals(("foo/base,key1=val1/other/elements",
+            {"key2": "val2"}), split_segment_parameters(
+                "foo/base,key1=val1/other/elements,key2=val2"))
+
     def test_win32_strip_local_trailing_slash(self):
         strip = urlutils._win32_strip_local_trailing_slash
         self.assertEqual('file://', strip('file://'))

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2010-05-13 17:32:55 +0000
+++ bzrlib/transform.py	2010-05-25 17:27:52 +0000
@@ -1792,7 +1792,7 @@
         parent_keys = [(file_id, self._file_revision(t, file_id)) for t in
                        self._iter_parent_trees()]
         vf.add_lines((file_id, tree_revision), parent_keys,
-                     self.get_file(file_id).readlines())
+                     self.get_file_lines(file_id))
         repo = self._get_repository()
         base_vf = repo.texts
         if base_vf not in vf.fallback_versionedfiles:
@@ -2460,8 +2460,12 @@
     if entry.kind == "directory":
         return True
     if entry.kind == "file":
-        if tree.get_file(file_id).read() == file(target_path, 'rb').read():
-            return True
+        f = file(target_path, 'rb')
+        try:
+            if tree.get_file_text(file_id) == f.read():
+                return True
+        finally:
+            f.close()
     elif entry.kind == "symlink":
         if tree.get_symlink_target(file_id) == os.readlink(target_path):
             return True

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2010-05-04 06:22:51 +0000
+++ bzrlib/transport/__init__.py	2010-05-30 16:26:11 +0000
@@ -47,8 +47,6 @@
 """)
 
 from bzrlib.symbol_versioning import (
-        deprecated_method,
-        deprecated_function,
         DEPRECATED_PARAMETER,
         )
 from bzrlib.trace import (
@@ -1742,33 +1740,28 @@
 register_lazy_transport('ftp://', 'bzrlib.transport.ftp', 'FtpTransport')
 register_transport_proto('aftp://', help="Access using active FTP.")
 register_lazy_transport('aftp://', 'bzrlib.transport.ftp', 'FtpTransport')
-
-try:
-    import kerberos
-    kerberos_available = True
-except ImportError:
-    kerberos_available = False
-
-if kerberos_available:
-    # Default to trying GSSAPI authentication (if the kerberos module is
-    # available)
-    register_transport_proto('ftp+gssapi://', register_netloc=True)
-    register_lazy_transport('ftp+gssapi://', 'bzrlib.transport.ftp._gssapi',
-                            'GSSAPIFtpTransport')
-    register_transport_proto('aftp+gssapi://', register_netloc=True)
-    register_lazy_transport('aftp+gssapi://', 'bzrlib.transport.ftp._gssapi',
-                            'GSSAPIFtpTransport')
-    register_transport_proto('ftp+nogssapi://', register_netloc=True)
-    register_transport_proto('aftp+nogssapi://', register_netloc=True)
-
-    register_lazy_transport('ftp://', 'bzrlib.transport.ftp._gssapi',
-                            'GSSAPIFtpTransport')
-    register_lazy_transport('aftp://', 'bzrlib.transport.ftp._gssapi',
-                            'GSSAPIFtpTransport')
-    register_lazy_transport('ftp+nogssapi://', 'bzrlib.transport.ftp',
-                            'FtpTransport')
-    register_lazy_transport('aftp+nogssapi://', 'bzrlib.transport.ftp',
-                            'FtpTransport')
+register_transport_proto('gio+', help="Access using any GIO supported protocols.")
+register_lazy_transport('gio+', 'bzrlib.transport.gio_transport', 'GioTransport')
+
+
+# Default to trying GSSAPI authentication (if the kerberos module is
+# available)
+register_transport_proto('ftp+gssapi://', register_netloc=True)
+register_transport_proto('aftp+gssapi://', register_netloc=True)
+register_transport_proto('ftp+nogssapi://', register_netloc=True)
+register_transport_proto('aftp+nogssapi://', register_netloc=True)
+register_lazy_transport('ftp+gssapi://', 'bzrlib.transport.ftp._gssapi',
+                        'GSSAPIFtpTransport')
+register_lazy_transport('aftp+gssapi://', 'bzrlib.transport.ftp._gssapi',
+                        'GSSAPIFtpTransport')
+register_lazy_transport('ftp://', 'bzrlib.transport.ftp._gssapi',
+                        'GSSAPIFtpTransport')
+register_lazy_transport('aftp://', 'bzrlib.transport.ftp._gssapi',
+                        'GSSAPIFtpTransport')
+register_lazy_transport('ftp+nogssapi://', 'bzrlib.transport.ftp',
+                        'FtpTransport')
+register_lazy_transport('aftp+nogssapi://', 'bzrlib.transport.ftp',
+                        'FtpTransport')
 
 register_transport_proto('memory://')
 register_lazy_transport('memory://', 'bzrlib.transport.memory',

=== modified file 'bzrlib/transport/ftp/_gssapi.py'
--- bzrlib/transport/ftp/_gssapi.py	2009-10-06 08:24:14 +0000
+++ bzrlib/transport/ftp/_gssapi.py	2010-05-31 21:31:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,15 +19,13 @@
 See RFC2228 for details.
 """
 
-import base64, ftplib, getpass, socket
+import base64, ftplib
 
 from bzrlib import (
-    config,
     errors,
     )
 from bzrlib.trace import mutter
 from bzrlib.transport.ftp import FtpTransport
-from bzrlib.transport import register_transport_proto, register_transport
 
 try:
     import kerberos

=== added file 'bzrlib/transport/gio_transport.py'
--- bzrlib/transport/gio_transport.py	1970-01-01 00:00:00 +0000
+++ bzrlib/transport/gio_transport.py	2010-05-28 18:52:03 +0000
@@ -0,0 +1,584 @@
+# Copyright (C) 2010 Canonical Ltd.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+#
+# Author: Mattias Eriksson
+
+"""Implementation of Transport over gio.
+
+Written by Mattias Eriksson <snaggen@acc.umu.se> based on the ftp transport.
+
+It provides the gio+XXX:// protocols where XXX is any of the protocols
+supported by gio.
+"""
+from cStringIO import StringIO
+import getpass
+import os
+import random
+import socket
+import stat
+import urllib
+import time
+import sys
+import getpass
+import urlparse
+
+from bzrlib import (
+    config,
+    errors,
+    osutils,
+    urlutils,
+    debug,
+    ui,
+    )
+from bzrlib.trace import mutter, warning
+from bzrlib.transport import (
+    FileStream,
+    ConnectedTransport,
+    _file_streams,
+    Server,
+    )
+
+from bzrlib.tests.test_server import TestServer
+
+try:
+    import glib
+except ImportError, e:
+    raise errors.DependencyNotPresent('glib', e)
+try:
+    import gio
+except ImportError, e:
+    raise errors.DependencyNotPresent('gio', e)
+
+
+class GioLocalURLServer(TestServer):
+    """A pretend server for local transports, using file:// urls.
+
+    Of course no actual server is required to access the local filesystem, so
+    this just exists to tell the test code how to get to it.
+    """
+
+    def start_server(self):
+        pass
+
+    def get_url(self):
+        """See Transport.Server.get_url."""
+        return "gio+" + urlutils.local_path_to_url('')
+
+
+class GioFileStream(FileStream):
+    """A file stream object returned by open_write_stream.
+
+    This version uses GIO to perform writes.
+    """
+
+    def __init__(self, transport, relpath):
+        FileStream.__init__(self, transport, relpath)
+        self.gio_file = transport._get_GIO(relpath)
+        self.stream = self.gio_file.create()
+
+    def _close(self):
+        self.stream.close()
+
+    def write(self, bytes):
+        try:
+            #Using pump_string_file seems to make things crash
+            osutils.pumpfile(StringIO(bytes), self.stream)
+        except gio.Error, e:
+            #self.transport._translate_gio_error(e,self.relpath)
+            raise errors.BzrError(str(e))
+
+
+class GioStatResult(object):
+
+    def __init__(self, f):
+        info = f.query_info('standard::size,standard::type')
+        self.st_size = info.get_size()
+        type = info.get_file_type()
+        if (type == gio.FILE_TYPE_REGULAR):
+            self.st_mode = stat.S_IFREG
+        elif type == gio.FILE_TYPE_DIRECTORY:
+            self.st_mode = stat.S_IFDIR
+
+
+class GioTransport(ConnectedTransport):
+    """This is the transport agent for gio+XXX:// access."""
+
+    def __init__(self, base, _from_transport=None):
+        """Initialize the GIO transport and make sure the url is correct."""
+
+        if not base.startswith('gio+'):
+            raise ValueError(base)
+
+        (scheme, netloc, path, params, query, fragment) = \
+                urlparse.urlparse(base[len('gio+'):], allow_fragments=False)
+        if '@' in netloc:
+            user, netloc = netloc.rsplit('@', 1)
+        #Seems it is not possible to list supported backends for GIO
+        #so a hardcoded list it is then.
+        gio_backends = ['dav', 'file', 'ftp', 'obex', 'sftp', 'ssh', 'smb']
+        if scheme not in gio_backends:
+            raise errors.InvalidURL(base,
+                    extra="GIO support is only available for " + \
+                    ', '.join(gio_backends))
+
+        #Remove the username and password from the url we send to GIO
+        #by rebuilding the url again.
+        u = (scheme, netloc, path, '', '', '')
+        self.url = urlparse.urlunparse(u)
+
+        # And finally initialize super
+        super(GioTransport, self).__init__(base,
+            _from_transport=_from_transport)
+
+    def _relpath_to_url(self, relpath):
+        full_url = urlutils.join(self.url, relpath)
+        if isinstance(full_url, unicode):
+            raise errors.InvalidURL(full_url)
+        return full_url
+
+    def _get_GIO(self, relpath):
+        """Return the ftplib.GIO instance for this object."""
+        # Ensures that a connection is established
+        connection = self._get_connection()
+        if connection is None:
+            # First connection ever
+            connection, credentials = self._create_connection()
+            self._set_connection(connection, credentials)
+        fileurl = self._relpath_to_url(relpath)
+        file = gio.File(fileurl)
+        return file
+
+    def _auth_cb(self, op, message, default_user, default_domain, flags):
+        #really use bzrlib.auth get_password for this
+        #or possibly better gnome-keyring?
+        auth = config.AuthenticationConfig()
+        (scheme, urluser, urlpassword, host, port, urlpath) = \
+           urlutils.parse_url(self.url)
+        user = None
+        if (flags & gio.ASK_PASSWORD_NEED_USERNAME and
+                flags & gio.ASK_PASSWORD_NEED_DOMAIN):
+            prompt = scheme.upper() + ' %(host)s DOMAIN\username'
+            user_and_domain = auth.get_user(scheme, host,
+                    port=port, ask=True, prompt=prompt)
+            (domain, user) = user_and_domain.split('\\', 1)
+            op.set_username(user)
+            op.set_domain(domain)
+        elif flags & gio.ASK_PASSWORD_NEED_USERNAME:
+            user = auth.get_user(scheme, host,
+                    port=port, ask=True)
+            op.set_username(user)
+        elif flags & gio.ASK_PASSWORD_NEED_DOMAIN:
+            #Don't know how common this case is, but anyway
+            #a DOMAIN and a username prompt should be the
+            #same so I will missuse the ui_factory get_username
+            #a little bit here.
+            prompt = scheme.upper() + ' %(host)s DOMAIN'
+            domain = ui.ui_factory.get_username(prompt=prompt)
+            op.set_domain(domain)
+
+        if flags & gio.ASK_PASSWORD_NEED_PASSWORD:
+            if user is None:
+                user = op.get_username()
+            password = auth.get_password(scheme, host,
+                    user, port=port)
+            op.set_password(password)
+        op.reply(gio.MOUNT_OPERATION_HANDLED)
+
+    def _mount_done_cb(self, obj, res):
+        try:
+            obj.mount_enclosing_volume_finish(res)
+            self.loop.quit()
+        except gio.Error, e:
+            self.loop.quit()
+            raise errors.BzrError("Failed to mount the given location: " + str(e));
+
+    def _create_connection(self, credentials=None):
+        if credentials is None:
+            user, password = self._user, self._password
+        else:
+            user, password = credentials
+
+        try:
+            connection = gio.File(self.url)
+            mount = None
+            try:
+                mount = connection.find_enclosing_mount()
+            except gio.Error, e:
+                if (e.code == gio.ERROR_NOT_MOUNTED):
+                    self.loop = glib.MainLoop()
+                    ui.ui_factory.show_message('Mounting %s using GIO' % \
+                            self.url)
+                    op = gio.MountOperation()
+                    if user:
+                        op.set_username(user)
+                    if password:
+                        op.set_password(password)
+                    op.connect('ask-password', self._auth_cb)
+                    m = connection.mount_enclosing_volume(op,
+                            self._mount_done_cb)
+                    self.loop.run()
+        except gio.Error, e:
+            raise errors.TransportError(msg="Error setting up connection:"
+                                        " %s" % str(e), orig_error=e)
+        return connection, (user, password)
+
+    def _reconnect(self):
+        """Create a new connection with the previously used credentials"""
+        credentials = self._get_credentials()
+        connection, credentials = self._create_connection(credentials)
+        self._set_connection(connection, credentials)
+
+    def _remote_path(self, relpath):
+        relative = urlutils.unescape(relpath).encode('utf-8')
+        remote_path = self._combine_paths(self._path, relative)
+        return remote_path
+
+    def has(self, relpath):
+        """Does the target location exist?"""
+        try:
+            if 'gio' in debug.debug_flags:
+                mutter('GIO has check: %s' % relpath)
+            f = self._get_GIO(relpath)
+            st = GioStatResult(f)
+            if stat.S_ISREG(st.st_mode) or stat.S_ISDIR(st.st_mode):
+                return True
+            return False
+        except gio.Error, e:
+            if e.code == gio.ERROR_NOT_FOUND:
+                return False
+            else:
+                self._translate_gio_error(e, relpath)
+
+    def get(self, relpath, decode=False, retries=0):
+        """Get the file at the given relative path.
+
+        :param relpath: The relative path to the file
+        :param retries: Number of retries after temporary failures so far
+                        for this operation.
+
+        We're meant to return a file-like object which bzr will
+        then read from. For now we do this via the magic of StringIO
+        """
+        try:
+            if 'gio' in debug.debug_flags:
+                mutter("GIO get: %s" % relpath)
+            f = self._get_GIO(relpath)
+            fin = f.read()
+            buf = fin.read()
+            fin.close()
+            ret = StringIO(buf)
+            return ret
+        except gio.Error, e:
+            #If we get a not mounted here it might mean
+            #that a bad path has been entered (or that mount failed)
+            if (e.code == gio.ERROR_NOT_MOUNTED):
+                raise errors.PathError(relpath,
+                  extra='Failed to get file, make sure the path is correct. ' \
+                  + str(e))
+            else:
+                self._translate_gio_error(e, relpath)
+
+    def put_file(self, relpath, fp, mode=None):
+        """Copy the file-like object into the location.
+
+        :param relpath: Location to put the contents, relative to base.
+        :param fp:       File-like or string object.
+        """
+        if 'gio' in debug.debug_flags:
+            mutter("GIO put_file %s" % relpath)
+        tmppath = '%s.tmp.%.9f.%d.%d' % (relpath, time.time(),
+                    os.getpid(), random.randint(0, 0x7FFFFFFF))
+        f = None
+        fout = None
+        try:
+            closed = True
+            try:
+                f = self._get_GIO(tmppath)
+                fout = f.create()
+                closed = False
+                length = self._pump(fp, fout)
+                fout.close()
+                closed = True
+                self.stat(tmppath)
+                dest = self._get_GIO(relpath)
+                f.move(dest, flags=gio.FILE_COPY_OVERWRITE)
+                f = None
+                if mode is not None:
+                    self._setmode(relpath, mode)
+                return length
+            except gio.Error, e:
+                self._translate_gio_error(e, relpath)
+        finally:
+            if not closed and fout is not None:
+                fout.close()
+            if f is not None and f.query_exists():
+                f.delete()
+
+    def mkdir(self, relpath, mode=None):
+        """Create a directory at the given path."""
+        try:
+            if 'gio' in debug.debug_flags:
+                mutter("GIO mkdir: %s" % relpath)
+            f = self._get_GIO(relpath)
+            f.make_directory()
+            self._setmode(relpath, mode)
+        except gio.Error, e:
+            self._translate_gio_error(e, relpath)
+
+    def open_write_stream(self, relpath, mode=None):
+        """See Transport.open_write_stream."""
+        if 'gio' in debug.debug_flags:
+            mutter("GIO open_write_stream %s" % relpath)
+        if mode is not None:
+            self._setmode(relpath, mode)
+        result = GioFileStream(self, relpath)
+        _file_streams[self.abspath(relpath)] = result
+        return result
+
+    def recommended_page_size(self):
+        """See Transport.recommended_page_size().
+
+        For FTP we suggest a large page size to reduce the overhead
+        introduced by latency.
+        """
+        if 'gio' in debug.debug_flags:
+            mutter("GIO recommended_page")
+        return 64 * 1024
+
+    def rmdir(self, relpath):
+        """Delete the directory at rel_path"""
+        try:
+            if 'gio' in debug.debug_flags:
+                mutter("GIO rmdir %s" % relpath)
+            st = self.stat(relpath)
+            if stat.S_ISDIR(st.st_mode):
+                f = self._get_GIO(relpath)
+                f.delete()
+            else:
+                raise errors.NotADirectory(relpath)
+        except gio.Error, e:
+            self._translate_gio_error(e, relpath)
+        except errors.NotADirectory, e:
+            #just pass it forward
+            raise e
+        except Exception, e:
+            mutter('failed to rmdir %s: %s' % (relpath, e))
+            raise errors.PathError(relpath)
+
+    def append_file(self, relpath, file, mode=None):
+        """Append the text in the file-like object into the final
+        location.
+        """
+        #GIO append_to seems not to append but to truncate
+        #Work around this.
+        if 'gio' in debug.debug_flags:
+            mutter("GIO append_file: %s" % relpath)
+        tmppath = '%s.tmp.%.9f.%d.%d' % (relpath, time.time(),
+                    os.getpid(), random.randint(0, 0x7FFFFFFF))
+        try:
+            result = 0
+            fo = self._get_GIO(tmppath)
+            fi = self._get_GIO(relpath)
+            fout = fo.create()
+            try:
+                info = GioStatResult(fi)
+                result = info.st_size
+                fin = fi.read()
+                self._pump(fin, fout)
+                fin.close()
+            #This separate except is to catch and ignore the
+            #gio.ERROR_NOT_FOUND for the already existing file.
+            #It is valid to open a non-existing file for append.
+            #This is caused by the broken gio append_to...
+            except gio.Error, e:
+                if e.code != gio.ERROR_NOT_FOUND:
+                    self._translate_gio_error(e, relpath)
+            length = self._pump(file, fout)
+            fout.close()
+            info = GioStatResult(fo)
+            if info.st_size != result + length:
+                raise errors.BzrError("Failed to append size after " \
+                      "(%d) is not original (%d) + written (%d) total (%d)" % \
+                      (info.st_size, result, length, result + length))
+            fo.move(fi, flags=gio.FILE_COPY_OVERWRITE)
+            return result
+        except gio.Error, e:
+            self._translate_gio_error(e, relpath)
+
+    def _setmode(self, relpath, mode):
+        """Set permissions on a path.
+
+        Only set permissions on Unix systems
+        """
+        if 'gio' in debug.debug_flags:
+            mutter("GIO _setmode %s" % relpath)
+        if mode:
+            try:
+                f = self._get_GIO(relpath)
+                f.set_attribute_uint32(gio.FILE_ATTRIBUTE_UNIX_MODE, mode)
+            except gio.Error, e:
+                if e.code == gio.ERROR_NOT_SUPPORTED:
+                    # Command probably not available on this server
+                    mutter("GIO Could not set permissions to %s on %s. %s",
+                        oct(mode), self._remote_path(relpath), str(e))
+                else:
+                    self._translate_gio_error(e, relpath)
+
+    def rename(self, rel_from, rel_to):
+        """Rename without special overwriting"""
+        try:
+            if 'gio' in debug.debug_flags:
+                mutter("GIO move (rename): %s => %s", rel_from, rel_to)
+            f = self._get_GIO(rel_from)
+            t = self._get_GIO(rel_to)
+            f.move(t)
+        except gio.Error, e:
+            self._translate_gio_error(e, rel_from)
+
+    def move(self, rel_from, rel_to):
+        """Move the item at rel_from to the location at rel_to"""
+        try:
+            if 'gio' in debug.debug_flags:
+                mutter("GIO move: %s => %s", rel_from, rel_to)
+            f = self._get_GIO(rel_from)
+            t = self._get_GIO(rel_to)
+            f.move(t, flags=gio.FILE_COPY_OVERWRITE)
+        except gio.Error, e:
+            self._translate_gio_error(e, relfrom)
+
+    def delete(self, relpath):
+        """Delete the item at relpath"""
+        try:
+            if 'gio' in debug.debug_flags:
+                mutter("GIO delete: %s", relpath)
+            f = self._get_GIO(relpath)
+            f.delete()
+        except gio.Error, e:
+            self._translate_gio_error(e, relpath)
+
+    def external_url(self):
+        """See bzrlib.transport.Transport.external_url."""
+        if 'gio' in debug.debug_flags:
+            mutter("GIO external_url", self.base)
+        # GIO external url
+        return self.base
+
+    def listable(self):
+        """See Transport.listable."""
+        if 'gio' in debug.debug_flags:
+            mutter("GIO listable")
+        return True
+
+    def list_dir(self, relpath):
+        """See Transport.list_dir."""
+        if 'gio' in debug.debug_flags:
+            mutter("GIO list_dir")
+        try:
+            entries = []
+            f = self._get_GIO(relpath)
+            children = f.enumerate_children(gio.FILE_ATTRIBUTE_STANDARD_NAME)
+            for child in children:
+                entries.append(urlutils.escape(child.get_name()))
+            return entries
+        except gio.Error, e:
+            self._translate_gio_error(e, relpath)
+
+    def iter_files_recursive(self):
+        """See Transport.iter_files_recursive.
+
+        This is cargo-culted from the SFTP transport"""
+        if 'gio' in debug.debug_flags:
+            mutter("GIO iter_files_recursive")
+        queue = list(self.list_dir("."))
+        while queue:
+            relpath = queue.pop(0)
+            st = self.stat(relpath)
+            if stat.S_ISDIR(st.st_mode):
+                for i, basename in enumerate(self.list_dir(relpath)):
+                    queue.insert(i, relpath + "/" + basename)
+            else:
+                yield relpath
+
+    def stat(self, relpath):
+        """Return the stat information for a file."""
+        try:
+            if 'gio' in debug.debug_flags:
+                mutter("GIO stat: %s", relpath)
+            f = self._get_GIO(relpath)
+            return GioStatResult(f)
+        except gio.Error, e:
+            self._translate_gio_error(e, relpath, extra='error w/ stat')
+
+    def lock_read(self, relpath):
+        """Lock the given file for shared (read) access.
+        :return: A lock object, which should be passed to Transport.unlock()
+        """
+        if 'gio' in debug.debug_flags:
+            mutter("GIO lock_read", relpath)
+
+        class BogusLock(object):
+            # The old RemoteBranch ignore lock for reading, so we will
+            # continue that tradition and return a bogus lock object.
+
+            def __init__(self, path):
+                self.path = path
+
+            def unlock(self):
+                pass
+
+        return BogusLock(relpath)
+
+    def lock_write(self, relpath):
+        """Lock the given file for exclusive (write) access.
+        WARNING: many transports do not support this, so trying avoid using it
+
+        :return: A lock object, whichshould be passed to Transport.unlock()
+        """
+        if 'gio' in debug.debug_flags:
+            mutter("GIO lock_write", relpath)
+        return self.lock_read(relpath)
+
+    def _translate_gio_error(self, err, path, extra=None):
+        if 'gio' in debug.debug_flags:
+            mutter("GIO Error: %s %s" % (str(err), path))
+        if extra is None:
+            extra = str(err)
+        if err.code == gio.ERROR_NOT_FOUND:
+            raise errors.NoSuchFile(path, extra=extra)
+        elif err.code == gio.ERROR_EXISTS:
+            raise errors.FileExists(path, extra=extra)
+        elif err.code == gio.ERROR_NOT_DIRECTORY:
+            raise errors.NotADirectory(path, extra=extra)
+        elif err.code == gio.ERROR_NOT_EMPTY:
+            raise errors.DirectoryNotEmpty(path, extra=extra)
+        elif err.code == gio.ERROR_BUSY:
+            raise errors.ResourceBusy(path, extra=extra)
+        elif err.code == gio.ERROR_PERMISSION_DENIED:
+            raise errors.PermissionDenied(path, extra=extra)
+        elif err.code == gio.ERROR_HOST_NOT_FOUND:
+            raise errors.PathError(path, extra=extra)
+        elif err.code == gio.ERROR_IS_DIRECTORY:
+            raise errors.PathError(path, extra=extra)
+        else:
+            mutter('unable to understand error for path: %s: %s', path, err)
+            raise errors.PathError(path,
+                    extra="Unhandled gio error: " + str(err))
+
+
+def get_test_permutations():
+    """Return the permutations to be used in testing."""
+    from bzrlib.tests import test_server
+    return [(GioTransport, GioLocalURLServer)]

=== modified file 'bzrlib/transport/http/_pycurl.py'
--- bzrlib/transport/http/_pycurl.py	2009-08-19 16:33:39 +0000
+++ bzrlib/transport/http/_pycurl.py	2010-05-31 21:31:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,16 +31,12 @@
 # from _curl_perform.  Not done because we may deprecate pycurl in the
 # future -- vila 20070212
 
-import os
 from cStringIO import StringIO
 import httplib
-import sys
 
 from bzrlib import (
     debug,
     errors,
-    trace,
-    __version__ as bzrlib_version,
     )
 import bzrlib
 from bzrlib.trace import mutter

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2010-05-11 08:36:16 +0000
+++ bzrlib/tree.py	2010-05-25 17:27:52 +0000
@@ -520,7 +520,7 @@
             parent_keys = [(file_id, self._file_revision(t, file_id)) for t in
                 self._iter_parent_trees()]
             vf.add_lines((file_id, last_revision), parent_keys,
-                         self.get_file(file_id).readlines())
+                         self.get_file_lines(file_id))
             repo = self.branch.repository
             base_vf = repo.texts
         else:

=== modified file 'bzrlib/ui/text.py'
--- bzrlib/ui/text.py	2010-05-20 18:23:17 +0000
+++ bzrlib/ui/text.py	2010-05-27 17:59:18 +0000
@@ -37,8 +37,6 @@
 
 """)
 
-from bzrlib.osutils import watch_sigwinch
-
 from bzrlib.ui import (
     UIFactory,
     NullProgressView,
@@ -62,8 +60,6 @@
         self.stderr = stderr
         # paints progress, network activity, etc
         self._progress_view = self.make_progress_view()
-        # hook up the signals to watch for terminal size changes
-        watch_sigwinch()
 
     def be_quiet(self, state):
         if state and not self._quiet:

=== modified file 'bzrlib/urlutils.py'
--- bzrlib/urlutils.py	2010-02-17 17:11:16 +0000
+++ bzrlib/urlutils.py	2010-05-27 22:10:42 +0000
@@ -469,6 +469,78 @@
     return url_base + head, tail
 
 
+def split_segment_parameters_raw(url):
+    """Split the subsegment of the last segment of a URL.
+
+    :param url: A relative or absolute URL
+    :return: (url, subsegments)
+    """
+    (parent_url, child_dir) = split(url)
+    subsegments = child_dir.split(",")
+    if len(subsegments) == 1:
+        return (url, [])
+    return (join(parent_url, subsegments[0]), subsegments[1:])
+
+
+def split_segment_parameters(url):
+    """Split the segment parameters of the last segment of a URL.
+
+    :param url: A relative or absolute URL
+    :return: (url, segment_parameters)
+    """
+    (base_url, subsegments) = split_segment_parameters_raw(url)
+    parameters = {}
+    for subsegment in subsegments:
+        (key, value) = subsegment.split("=", 1)
+        parameters[key] = value
+    return (base_url, parameters)
+
+
+def join_segment_parameters_raw(base, *subsegments):
+    """Create a new URL by adding subsegments to an existing one. 
+
+    This adds the specified subsegments to the last path in the specified
+    base URL. The subsegments should be bytestrings.
+
+    :note: You probably want to use join_segment_parameters instead.
+    """
+    if not subsegments:
+        return base
+    for subsegment in subsegments:
+        if type(subsegment) is not str:
+            raise TypeError("Subsegment %r is not a bytestring" % subsegment)
+        if "," in subsegment:
+            raise errors.InvalidURLJoin(", exists in subsegments",
+                                        base, subsegments)
+    return ",".join((base,) + subsegments)
+
+
+def join_segment_parameters(url, parameters):
+    """Create a new URL by adding segment parameters to an existing one.
+
+    The parameters of the last segment in the URL will be updated; if a
+    parameter with the same key already exists it will be overwritten.
+
+    :param url: A URL, as string
+    :param parameters: Dictionary of parameters, keys and values as bytestrings
+    """
+    (base, existing_parameters) = split_segment_parameters(url)
+    new_parameters = {}
+    new_parameters.update(existing_parameters)
+    for key, value in parameters.iteritems():
+        if type(key) is not str:
+            raise TypeError("parameter key %r is not a bytestring" % key)
+        if type(value) is not str:
+            raise TypeError("parameter value %r for %s is not a bytestring" %
+                (key, value))
+        if "=" in key:
+            raise errors.InvalidURLJoin("= exists in parameter key", url,
+                parameters)
+        new_parameters[key] = value
+    return join_segment_parameters_raw(base, 
+        *["%s=%s" % item for item in sorted(new_parameters.items())])
+
+
 def _win32_strip_local_trailing_slash(url):
     """Strip slashes after the drive letter"""
     if len(url) > WIN32_MIN_ABS_FILEURL_LENGTH:

=== modified file 'bzrlib/weavefile.py'
--- bzrlib/weavefile.py	2009-03-23 14:59:43 +0000
+++ bzrlib/weavefile.py	2010-05-31 21:31:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -118,7 +118,10 @@
 
     from weave import WeaveFormatError
 
-    lines = iter(f.readlines())
+    try:
+        lines = iter(f.readlines())
+    finally:
+        f.close()
 
     try:
         l = lines.next()

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-05-17 10:04:05 +0000
+++ bzrlib/workingtree.py	2010-05-25 17:27:52 +0000
@@ -527,7 +527,7 @@
 
         # Now we have the parents of this content
         annotator = self.branch.repository.texts.get_annotator()
-        text = self.get_file(file_id).read()
+        text = self.get_file_text(file_id)
         this_key =(file_id, default_revision)
         annotator.add_special_text(this_key, file_parent_keys, text)
         annotations = [(key[-1], line)

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml_serializer.py	2010-05-25 17:27:52 +0000
@@ -83,8 +83,11 @@
 
     def read_inventory(self, f, revision_id=None):
         try:
-            return self._unpack_inventory(self._read_element(f),
-                revision_id=None)
+            try:
+                return self._unpack_inventory(self._read_element(f),
+                    revision_id=None)
+            finally:
+                f.close()
         except ParseError, e:
             raise errors.UnexpectedInventoryFormat(e)
 

=== added file 'contrib/zsh/README'
--- contrib/zsh/README	1970-01-01 00:00:00 +0000
+++ contrib/zsh/README	2010-05-25 11:34:35 +0000
@@ -0,0 +1,19 @@
+This directory used to contain a shell completion function for zsh.
+That script has been unmaintained since 2005, though.  Zsh itself does
+ship a _bzr completion function, and has done so for quite some time
+now.  So we suggest you use the version installed with your zsh
+instead of the version that used to be located in this directory.
+
+Note that the shell-complete builtin of bzr does provide completion
+information in a style suitable for zsh.  There are some completion
+scripts for zsh in the wild that make use of this feature, although
+none of these scripts is officially supported by the bzr developers.
+
+Also note that recent versions of bzr (starting with the 2.3 series)
+do include a bash_completion plugin. It should be possible to improve
+this in such a way that it generates code for zsh instead of bash.  So
+if you want better zsh completion, this might be the place to start.
+
+References:
+https://bugs.launchpad.net/bzr/+bug/560030
+http://zsh.git.sourceforge.net/git/gitweb.cgi?p=zsh/zsh;a=history;f=Completion/Unix/Command/_bzr

=== removed file 'contrib/zsh/_bzr'
--- contrib/zsh/_bzr	2005-11-18 08:10:07 +0000
+++ contrib/zsh/_bzr	1970-01-01 00:00:00 +0000
@@ -1,316 +0,0 @@
-#compdef bzr
-
-# Rudimentary zsh completion support for bzr.
-
-# -S means there are no options after a -- and that argument is ignored
-
-# To use this you must arrange for it to be in a directory that is on
-# your $fpath, and also for compinit to be run.  I don't understand
-# how to get zsh to reload this file when it changes, other than by
-# starting a new zsh.
-
-local _bzr_subcommands expl curcontext="$curcontext" state line
-local bzrRoot helpArgs parentFile
-typeset -A opt_args
-
-helpArgs=( '(--help)-h[show help message]' '(-h)--help[show help message]' )
-bzrRoot=$(bzr root 2> /dev/null)
-parentFile=$bzrRoot/.bzr/parent
-
-if [[ $service == "bzr" ]]; then
-    _arguments -C -A "-*" \
-    '*::command:->subcmd' && return 0
-
-    if (( CURRENT == 1 )); then
-      _bzr_subcommands=(${(f)"$(_call_program bzr bzr shell-complete)"})
-      _describe -t subcommand 'subcommand' _bzr_subcommands
-      return
-    fi
-
-    service="$words[1]"
-    curcontext="${curcontext%:*}=$service:"
-fi
-
-_unknownFiles() {
-    local fileList;
-    fileList=(${(ps:\0:)"$(bzr ls --null --unknown)"})
-    compadd -af fileList
-    return 0
-}
-
-_unknownRoot() {
-    local fileList;
-    fileList=(${(ps:\0:)"$(bzr ls --null --from-root --unknown)"})
-    compadd -af fileList
-    return 0
-}
-
-_versionedFiles() {
-    local fileList;
-    fileList=(${(ps:\0:)"$(bzr ls --null --versioned)"})
-    compadd -af fileList
-    return 0
-}
-
-case $service in
-    (add)
-       _arguments $helpArgs \
-       '--no-recurse[do not recurse into subdirectories]' \
-       '(-q)--quiet' \
-       '(--quiet)-q' \
-       '*:unknown files:_unknownFiles'
-    ;;
-
-    (annotate|praise|blame)
-        _arguments $helpArgs '*:files:_versionedFiles'
-    ;;
-
-    (clone|branch|get)
-        if (( CURRENT == 2 )); then
-            _arguments $helpArgs \
-            '(-r)--revision:rev:' \
-            '(--revision)-r:rev:' \
-            '--basis[specify basis branch]:basis:' \
-            '*:FROM_LOCATION:_files -/'
-        elif (( CURRENT == 3 )); then
-            _arguments $helpArgs \
-            '(-r)--revision:rev:' \
-            '(--revision)-r:rev:' \
-            '--basis[specify basis branch]:basis:' \
-            '*:TO_LOCATION:_files -/'
-        fi
-    ;;
-
-    (rename|mv)
-        if (( CURRENT == 2 )); then
-            _arguments $helpArgs '*:old name:_versionedFiles'
-        else
-            _arguments $helpArgs '*:new name:'
-        fi
-    ;;
-
-    (cat)
-        _arguments $helpArgs \
-        '(-r)--revision:rev:' \
-        '(--revision)-r:rev:' \
-        '*:file:_versionedFiles'
-    ;;
-
-    (root)
-        _arguments $helpArgs '*:file:_files'
-    ;;
-
-    (log)
-        _arguments $helpArgs \
-        '(-r)--revision[revision or range]:rev or rev range:' \
-        '(--revision)-r[revision or range]:rev or rev range:' \
-        '(--verbose)-v[show revision manifest]' \
-        '(-v)--verbose[show revision manifest]' \
-        '(--short --long)-l[use long format (default)]' \
-        '(--short -l)--long[use long format (default)]' \
-        '(-l --long)--short[use short format]' \
-        '(--message)-m[specify regexp]:regexp:' \
-        '(-m)--message[specify regexp]:regexp:' \
-        '--show-ids[show file IDs]' \
-        '--forward[reverse direction of revisions]' \
-        '--timezoe[specify timezone for dates]:timezone:' \
-        '*:file:_versionedFiles'
-    ;;
-
-    (resolve)
-        _arguments $helpArgs '--all' '*:file:_versionedFiles'
-    ;;
-
-    (status|st|stat)
-        _arguments $helpArgs \
-        '--all[include unchanged versioned files]' \
-        '--show-ids[show file IDs]' \
-        '*:file:_versionedFiles'
-    ;;
-
-    (check)
-        _arguments $helpArgs \
-        '(--verbose)-v' \
-        '(-v)--verbose' \
-        '*:DIR:_files -/'
-    ;;
-
-    (mkdir|upgrade|renames)
-        _arguments $helpArgs '*:DIR:_files -/'
-    ;;
-
-    (remove|rm)
-        _arguments $helpArgs \
-        '(--verbose)-v' \
-        '(-v)--verbose' \
-        '*:file:_versionedFiles'
-    ;;
-
-    (pull)
-        _arguments $helpArgs \
-        '--remember[Remember the specified location as a default]' \
-        '--overwrite[Ignore differences, overwrite unconditionally]' \
-        '*:local repository:_files -/'
-        [[ -r $parentFile ]] && compadd -X "Completing parents" $(cat $parentFile)
-    ;;
-
-    (missing|miss|mis)
-        _arguments $helpArgs \
-        '(--verbose -q --quiet)-v' \
-        '(-v -q --quiet)--verbose' \
-        '(--verbose -v --quiet)-q' \
-        '(-v -q --verbose)--quiet' \
-        '*:local repository:_files -/'
-        [[ -r $parentFile ]] && compadd -X "Completing parents" $(cat $parentFile)
-    ;;
-
-    (commit|checkin|ci)
-        _arguments $helpArgs \
-        '(--message)-m[commit message]:message text:' \
-        '(-m)--message[commit message]:message text:' \
-        '(--file)-F[commit message from file]:message file:' \
-        '(-F)--file[commit message from file]:message file:' \
-        '--unchanged[include unchanged files]' \
-        '(--verbose)-v' \
-        '(-v)--verbose' \
-        '*:modified files:_versionedFiles'
-    ;;
-
-    (conflicts|added|deleted|modified|unknowns|directories|ignored)
-        _arguments $helpArgs
-    ;;
-
-    (revno|init|version)
-        _arguments $helpArgs
-    ;;
-
-    (whoami)
-        _arguments $helpArgs '--email[only show e-mail address]' 
-    ;;
-
-    (inventory)
-        _arguments $helpArgs \
-        '(-r)--revision[show inventory of a revision]:revision:' \
-        '(--revision)-r[show inventory of a revision]:revision:' \
-        '--show-ids[show file IDs]'
-    ;;
-
-    (diff|dif|di)
-        _arguments $helpArgs \
-        '(-r)--revision:revision:' \
-        '(--revision)-r:revision:' \
-        '--diff-options[options to pass to gdiff]:diff options:' \
-        '*:files:_files'
-    ;;
-
-    (export)
-        _arguments $helpArgs \
-        '(-r)--revision:revision:' \
-        '(--revision)-r:revision:' \
-        '--format=[format of exported file]:format:(dir tar tgz tbz2)' \
-        '--root[root directory of patch]:_files -/' \
-        '*:destination:_files'
-    ;;
-
-    (ignore)
-        _arguments $helpArgs '*:NAME_PATTERN:_unknownRoot'
-    ;;
-
-    (info)
-        _arguments $helpArgs '*:branch:_files -/'
-    ;;
-
-    (testament)
-        _arguments $helpArgs \
-        '(-r)--revision:revision:' \
-        '(--revision)-r:revision:' \
-        '(--long)-l' \
-        '(-l)--long' \
-        '*:branch:_files -/'
-    ;;
-
-    (revert|merge-revert)
-        _arguments $helpArgs \
-        '(-r)--revision:revision:' \
-        '(--revision)-r:revision:' \
-        '--no-backup[skip generation of backup~ files]' \
-        '*:file:_versionedFiles'
-    ;;
-
-    (merge)
-        _arguments $helpArgs \
-        '(-r)--revision:revision:' \
-        '(--revision)-r:revision:' \
-        '--reprocess[Reprocess to reduce spurious conflicts]' \
-        '--show-base[Show base revision text in conflicts]' \
-        '--force[ignore uncommitted changes]' \
-        '--merge-type:merge type:(diff3 merge3 weave)' \
-        '*:local repository:_files -/'
-        [[ -r $parentFile ]] && compadd -X "Completing parents" $(cat $parentFile)
-    ;;
-
-    (ls)
-        _arguments $helpArgs \
-        '(--verbose)-v[display more information]' \
-        '(-v)--verbose[display more information]' \
-        '(-r)--revision:revision:' \
-        '(--revision)-r:revision:' \
-        '--from-root[Print all paths from the root of the branch]' \
-        '--non-recursive[Do not recurse into subdirectories]' \
-        '--null[Null separate the files]' \
-        '--ignored[Print ignored files]' \
-        '--unknown[Print unknown files]' \
-        '--versioned[Print versioned files]'
-    ;;
-
-    (move)
-        if (( CURRENT == 2 )); then
-            _arguments $helpArgs '*:files:_versionedFiles'
-        else
-            _arguments '*:destination dir:_files -/'
-        fi
-    ;;
-
-    (help)
-        _bzr_subcommands=(${(f)"$(_call_program bzr bzr shell-complete)"})
-        _arguments $helpArgs \
-        '(--long)-l' \
-        '(-l)--long' \
-        '*:subcmds:->cmds'
-        _describe -t subcommand 'subcommand' _bzr_subcommands
-    ;;
-
-    # Plugins
-
-    (visualize|visualise|viz|vis)
-        _arguments $helpArgs \
-            '(-r)--revision[starting revision]:rev:' \
-            '(--revision)-r[starting revision]:rev:'
-    ;;
-
-    (gannotate|gblame|gpraise)
-        _arguments $helpArgs \
-            '--all[show annotations on all lines]' \
-            '--plain[do not hightlight annotation lines]' \
-            '*:files:_versionedFiles'
-    ;;
-
-    (push)
-        _arguments $helpArgs \
-        '--overwrite[Ignore differences, overwrite unconditionally]' \
-        '*:local repository:_files -/'
-        [[ -r $parentFile ]] && compadd -X "Completing parents" $(cat $parentFile)
-    ;;
-
-    (clean-tree)
-        _arguments $helpArgs \
-        '--dry-run[show files to delete instead of deleting them]' \
-        '--ignored[delete all ignored files]' \
-        '--detritus[delete conflict files, merge backups, failed self-tests, *~, *.tmp, etc]'
-    ;;
-
-
-    (*)
-        _message "unknown bzr command completion: $service"
-    ;;
-esac

=== modified file 'doc/developers/HACKING.txt'
--- doc/developers/HACKING.txt	2010-05-12 11:04:21 +0000
+++ doc/developers/HACKING.txt	2010-05-27 04:55:13 +0000
@@ -12,8 +12,7 @@
 document, send a merge request or new text to the mailing list.
 
 The latest developer documentation can be found online at
-http://doc.bazaar-vcs.org/developers/.
-
+http://doc.bazaar.canonical.com/developers/.
 
 Getting Started
 ###############
@@ -29,14 +28,12 @@
 To answer these questions and more, take a moment to explore the
 overall Bazaar Platform. Here are some links to browse:
 
-* The Plugins page on the Wiki - http://bazaar-vcs.org/BzrPlugins
+* The Plugins page on the Wiki - http://wiki.bazaar.canonical.com/BzrPlugins
 
 * The Bazaar product family on Launchpad - https://launchpad.net/bazaar
 
 * Bug Tracker for the core product - https://bugs.launchpad.net/bzr/
 
-* Blueprint Tracker for the core product - https://blueprints.launchpad.net/bzr/
-
 If nothing else, perhaps you'll find inspiration in how other developers
 have solved their challenges.
 
@@ -55,7 +52,7 @@
 
 There is a very active community around Bazaar. Mostly we meet on IRC
 (#bzr on irc.freenode.net) and on the mailing list. To join the Bazaar
-community, see http://bazaar-vcs.org/BzrSupport.
+community, see http://wiki.bazaar.canonical.com/BzrSupport.
 
 If you are planning to make a change, it's a very good idea to mention it
 on the IRC channel and/or on the mailing list. There are many advantages
@@ -128,6 +125,9 @@
 "Propose for merging into another branch".  Select "~bzr/bzr/trunk" to hand
 your changes off to the Bazaar developers for review and merging.
 
+Alternatively, after pushing you can use the ``lp-propose`` command to 
+create the merge proposal.
+
 Using a meaningful name for your branch will help you and the reviewer(s)
 better track the submission. Use a very succint description of your submission
 and prefix it with bug number if needed (lp:~mbp/bzr/484558-merge-directory
@@ -135,6 +135,30 @@
 (lp:~jameinel/bzr/export-file-511987).
 
 
+Review cover letters
+--------------------
+
+Please put a "cover letter" on your merge request explaining:
+
+* the reason **why** you're making this change
+
+* **how** this change achieves this purpose
+
+* anything else you may have fixed in passing
+
+* anything significant that you thought of doing, such as a more
+  extensive fix or a different approach, but didn't or couldn't do now
+
+A good cover letter makes reviewers' lives easier because they can decide
+from the letter whether they agree with the purpose and approach, and then
+assess whether the patch actually does what the cover letter says.
+Explaining any "drive-by fixes" or roads not taken may also avoid queries
+from the reviewer.  All in all this should give faster and better reviews.
+Sometimes writing the cover letter helps the submitter realize something
+else they need to do.  The size of the cover letter should be proportional
+to the size and complexity of the patch.
+
+
 Why make a local copy of bzr.dev?
 ---------------------------------
 
@@ -177,7 +201,7 @@
 
 * Launchpad - https://launchpad.net/
 
-* Bazaar - http://bazaar-vcs.org/
+* Bazaar - http://bazaar.canonical.com/
 
 * Patch Queue Manager - https://launchpad.net/pqm/
 
@@ -190,7 +214,7 @@
 ================================================
 
 Bazaar supports many ways of organising your work. See
-http://bazaar-vcs.org/SharedRepositoryLayouts for a summary of the
+http://wiki.bazaar.canonical.com/SharedRepositoryLayouts for a summary of the
 popular alternatives.
 
 Of course, the best choice for you will depend on numerous factors:
@@ -267,364 +291,7 @@
 <http://starship.python.net/crew/mwh/bzrlibapi/>.
 
 See also the `Bazaar Architectural Overview
-<http://doc.bazaar-vcs.org/developers/overview.html>`_.
-
-
-Coding Style Guidelines
-#######################
-
-hasattr and getattr
-===================
-
-``hasattr`` should not be used because it swallows exceptions including
-``KeyboardInterrupt``.  Instead, say something like ::
-
-  if getattr(thing, 'name', None) is None
-
-
-Code layout
-===========
-
-Please write PEP-8__ compliant code.
-
-__ http://www.python.org/peps/pep-0008.html
-
-One often-missed requirement is that the first line of docstrings
-should be a self-contained one-sentence summary.
-
-We use 4 space indents for blocks, and never use tab characters.  (In vim,
-``set expandtab``.)
-
-Trailing white space should be avoided, but is allowed.
-You should however not make lots of unrelated white space changes.
-
-Unix style newlines (LF) are used.
-
-Each file must have a newline at the end of it.
-
-Lines should be no more than 79 characters if at all possible.
-Lines that continue a long statement may be indented in either of
-two ways:
-
-within the parenthesis or other character that opens the block, e.g.::
-
-    my_long_method(arg1,
-                   arg2,
-                   arg3)
-
-or indented by four spaces::
-
-    my_long_method(arg1,
-        arg2,
-        arg3)
-
-The first is considered clearer by some people; however it can be a bit
-harder to maintain (e.g. when the method name changes), and it does not
-work well if the relevant parenthesis is already far to the right.  Avoid
-this::
-
-     self.legbone.kneebone.shinbone.toebone.shake_it(one,
-                                                     two,
-                                                     three)
-
-but rather ::
-
-     self.legbone.kneebone.shinbone.toebone.shake_it(one,
-         two,
-         three)
-
-or ::
-
-     self.legbone.kneebone.shinbone.toebone.shake_it(
-         one, two, three)
-
-For long lists, we like to add a trailing comma and put the closing
-character on the following line.  This makes it easier to add new items in
-future::
-
-    from bzrlib.goo import (
-        jam,
-        jelly,
-        marmalade,
-        )
-
-There should be spaces between function parameters, but not between the
-keyword name and the value::
-
-    call(1, 3, cheese=quark)
-
-In emacs::
-
-    ;(defface my-invalid-face
-    ;  '((t (:background "Red" :underline t)))
-    ;  "Face used to highlight invalid constructs or other uglyties"
-    ;  )
-
-    (defun my-python-mode-hook ()
-     ;; setup preferred indentation style.
-     (setq fill-column 79)
-     (setq indent-tabs-mode nil) ; no tabs, never, I will not repeat
-    ;  (font-lock-add-keywords 'python-mode
-    ;                         '(("^\\s *\t" . 'my-invalid-face) ; Leading tabs
-    ;                            ("[ \t]+$" . 'my-invalid-face)  ; Trailing spaces
-    ;                            ("^[ \t]+$" . 'my-invalid-face)); Spaces only
-    ;                          )
-     )
-
-    (add-hook 'python-mode-hook 'my-python-mode-hook)
-
-The lines beginning with ';' are comments. They can be activated
-if one want to have a strong notice of some tab/space usage
-violations.
-
-
-Module Imports
-==============
-
-* Imports should be done at the top-level of the file, unless there is
-  a strong reason to have them lazily loaded when a particular
-  function runs.  Import statements have a cost, so try to make sure
-  they don't run inside hot functions.
-
-* Module names should always be given fully-qualified,
-  i.e. ``bzrlib.hashcache`` not just ``hashcache``.
-
-
-Naming
-======
-
-Functions, methods or members that are relatively private are given
-a leading underscore prefix.  Names without a leading underscore are
-public not just across modules but to programmers using bzrlib as an
-API.
-
-We prefer class names to be concatenated capital words (``TestCase``)
-and variables, methods and functions to be lowercase words joined by
-underscores (``revision_id``, ``get_revision``).
-
-For the purposes of naming some names are treated as single compound
-words: "filename", "revno".
-
-Consider naming classes as nouns and functions/methods as verbs.
-
-Try to avoid using abbreviations in names, because there can be
-inconsistency if other people use the full name.
-
-
-Standard Names
-==============
-
-``revision_id`` not ``rev_id`` or ``revid``
-
-Functions that transform one thing to another should be named ``x_to_y``
-(not ``x2y`` as occurs in some old code.)
-
-
-Destructors
-===========
-
-Python destructors (``__del__``) work differently to those of other
-languages.  In particular, bear in mind that destructors may be called
-immediately when the object apparently becomes unreferenced, or at some
-later time, or possibly never at all.  Therefore we have restrictions on
-what can be done inside them.
-
- 0. If you think you need to use a ``__del__`` method ask another
-    developer for alternatives.  If you do need to use one, explain
-    why in a comment.
-
- 1. Never rely on a ``__del__`` method running.  If there is code that
-    must run, do it from a ``finally`` block instead.
-
- 2. Never ``import`` from inside a ``__del__`` method, or you may crash the
-    interpreter!!
-
- 3. In some places we raise a warning from the destructor if the object
-    has not been cleaned up or closed.  This is considered OK: the warning
-    may not catch every case but it's still useful sometimes.
-
-
-Cleanup methods
-===============
-
-Often when something has failed later code, including cleanups invoked
-from ``finally`` blocks, will fail too.  These secondary failures are
-generally uninteresting compared to the original exception.  So use the
-``only_raises`` decorator (from ``bzrlib.decorators``) for methods that
-are typically called in ``finally`` blocks, such as ``unlock`` methods.
-For example, ``@only_raises(LockNotHeld, LockBroken)``.  All errors that
-are unlikely to be a knock-on failure from a previous failure should be
-allowed.
-
-
-Factories
-=========
-
-In some places we have variables which point to callables that construct
-new instances.  That is to say, they can be used a lot like class objects,
-but they shouldn't be *named* like classes::
-
-> I think that things named FooBar should create instances of FooBar when
-> called. Its plain confusing for them to do otherwise. When we have
-> something that is going to be used as a class - that is, checked for via
-> isinstance or other such idioms, them I would call it foo_class, so that
-> it is clear that a callable is not sufficient. If it is only used as a
-> factory, then yes, foo_factory is what I would use.
-
-
-Registries
-==========
-
-Several places in Bazaar use (or will use) a registry, which is a
-mapping from names to objects or classes.  The registry allows for
-loading in registered code only when it's needed, and keeping
-associated information such as a help string or description.
-
-
-InterObject and multiple dispatch
-=================================
-
-The ``InterObject`` provides for two-way `multiple dispatch`__: matching
-up for example a source and destination repository to find the right way
-to transfer data between them.
-
-.. __: http://en.wikipedia.org/wiki/Multiple_dispatch
-
-There is a subclass ``InterObject`` classes for each type of object that is
-dispatched this way, e.g. ``InterRepository``.  Calling ``.get()`` on this
-class will return an ``InterObject`` instance providing the best match for
-those parameters, and this instance then has methods for operations
-between the objects.
-
-::
-
-  inter = InterRepository.get(source_repo, target_repo)
-  inter.fetch(revision_id)
-
-``InterRepository`` also acts as a registry-like object for its
-subclasses, and they can be added through ``.register_optimizer``.  The
-right one to run is selected by asking each class, in reverse order of
-registration, whether it ``.is_compatible`` with the relevant objects.
-
-Lazy Imports
-============
-
-To make startup time faster, we use the ``bzrlib.lazy_import`` module to
-delay importing modules until they are actually used. ``lazy_import`` uses
-the same syntax as regular python imports. So to import a few modules in a
-lazy fashion do::
-
-  from bzrlib.lazy_import import lazy_import
-  lazy_import(globals(), """
-  import os
-  import subprocess
-  import sys
-  import time
-
-  from bzrlib import (
-     errors,
-     transport,
-     revision as _mod_revision,
-     )
-  import bzrlib.transport
-  import bzrlib.xml5
-  """)
-
-At this point, all of these exist as a ``ImportReplacer`` object, ready to
-be imported once a member is accessed. Also, when importing a module into
-the local namespace, which is likely to clash with variable names, it is
-recommended to prefix it as ``_mod_<module>``. This makes it clearer that
-the variable is a module, and these object should be hidden anyway, since
-they shouldn't be imported into other namespaces.
-
-While it is possible for ``lazy_import()`` to import members of a module
-when using the ``from module import member`` syntax, it is recommended to
-only use that syntax to load sub modules ``from module import submodule``.
-This is because variables and classes can frequently be used without
-needing a sub-member for example::
-
-  lazy_import(globals(), """
-  from module import MyClass
-  """)
-
-  def test(x):
-      return isinstance(x, MyClass)
-
-This will incorrectly fail, because ``MyClass`` is a ``ImportReplacer``
-object, rather than the real class.
-
-It also is incorrect to assign ``ImportReplacer`` objects to other variables.
-Because the replacer only knows about the original name, it is unable to
-replace other variables. The ``ImportReplacer`` class will raise an
-``IllegalUseOfScopeReplacer`` exception if it can figure out that this
-happened. But it requires accessing a member more than once from the new
-variable, so some bugs are not detected right away.
-
-
-The Null revision
-=================
-
-The null revision is the ancestor of all revisions.  Its revno is 0, its
-revision-id is ``null:``, and its tree is the empty tree.  When referring
-to the null revision, please use ``bzrlib.revision.NULL_REVISION``.  Old
-code sometimes uses ``None`` for the null revision, but this practice is
-being phased out.
-
-
-Object string representations
-=============================
-
-Python prints objects using their ``__repr__`` method when they are
-written to logs, exception tracebacks, or the debugger.  We want
-objects to have useful representations to help in determining what went
-wrong.
-
-If you add a new class you should generally add a ``__repr__`` method
-unless there is an adequate method in a parent class.  There should be a
-test for the repr.
-
-Representations should typically look like Python constructor syntax, but
-they don't need to include every value in the object and they don't need
-to be able to actually execute.  They're to be read by humans, not
-machines.  Don't hardcode the classname in the format, so that we get the
-correct value if the method is inherited by a subclass.  If you're
-printing attributes of the object, including strings, you should normally
-use ``%r`` syntax (to call their repr in turn).
-
-Try to avoid the representation becoming more than one or two lines long.
-(But balance this against including useful information, and simplicity of
-implementation.)
-
-Because repr methods are often called when something has already gone
-wrong, they should be written somewhat more defensively than most code.
-The object may be half-initialized or in some other way in an illegal
-state.  The repr method shouldn't raise an exception, or it may hide the
-(probably more useful) underlying exception.
-
-Example::
-
-    def __repr__(self):
-        return '%s(%r)' % (self.__class__.__name__,
-                           self._transport)
-
-
-Exception handling
-==================
-
-A bare ``except`` statement will catch all exceptions, including ones that
-really should terminate the program such as ``MemoryError`` and
-``KeyboardInterrupt``.  They should rarely be used unless the exception is
-later re-raised.  Even then, think about whether catching just
-``Exception`` (which excludes system errors in Python2.5 and later) would
-be better.
-
-
-Test coverage
-=============
-
-All code should be exercised by the test suite.  See the `Bazaar Testing
-Guide <http://doc.bazaar-vcs.org/developers/testing.html>`_ for detailed
-information about writing tests.
+<http://doc.bazaar.canonical.com/developers/overview.html>`_.
 
 
 Core Topics
@@ -891,35 +558,6 @@
 final fullstop.  If long, they may contain newlines to break the text.
 
 
-Assertions
-==========
-
-Do not use the Python ``assert`` statement, either in tests or elsewhere.
-A source test checks that it is not used.  It is ok to explicitly raise
-AssertionError.
-
-Rationale:
-
- * It makes the behaviour vary depending on whether bzr is run with -O
-   or not, therefore giving a chance for bugs that occur in one case or
-   the other, several of which have already occurred: assertions with
-   side effects, code which can't continue unless the assertion passes,
-   cases where we should give the user a proper message rather than an
-   assertion failure.
- * It's not that much shorter than an explicit if/raise.
- * It tends to lead to fuzzy thinking about whether the check is
-   actually needed or not, and whether it's an internal error or not
- * It tends to cause look-before-you-leap patterns.
- * It's unsafe if the check is needed to protect the integrity of the
-   user's data.
- * It tends to give poor messages since the developer can get by with
-   no explanatory text at all.
- * We can't rely on people always running with -O in normal use, so we
-   can't use it for tests that are actually expensive.
- * Expensive checks that help developers are better turned on from the
-   test suite or a -D flag.
- * If used instead of ``self.assert*()`` in tests it makes them falsely pass with -O.
-
 
 Documenting Changes
 ===================
@@ -1143,17 +781,6 @@
 valid characters are generated where possible.
 
 
-Portability Tips
-================
-
-The ``bzrlib.osutils`` module has many useful helper functions, including
-some more portable variants of functions in the standard library.
-
-In particular, don't use ``shutil.rmtree`` unless it's acceptable for it
-to fail on Windows if some files are readonly or still open elsewhere.
-Use ``bzrlib.osutils.rmtree`` instead.
-
-
 C Extension Modules
 ===================
 
@@ -1196,8 +823,7 @@
 Making Installers for OS Windows
 ================================
 To build a win32 installer, see the instructions on the wiki page:
-http://bazaar-vcs.org/BzrWin32Installer
-
+http://wiki.bazaar.canonical.com/BzrWin32Installer
 
 Core Developer Tasks
 ####################
@@ -1216,7 +842,7 @@
 * reviewing changes
 * reviewing blueprints
 * planning releases
-* managing releases (see `Releasing Bazaar <http://doc.bazaar-vcs.org/developers/releasing.html>`_)
+* managing releases (see `Releasing Bazaar <http://doc.bazaar.canonical.com/developers/releasing.html>`_)
 
 .. note::
   Removing barriers to community participation is a key reason for adopting
@@ -1268,7 +894,7 @@
 Of the many workflows supported by Bazaar, the one adopted for Bazaar
 development itself is known as "Decentralized with automatic gatekeeper".
 To repeat the explanation of this given on
-http://bazaar-vcs.org/Workflows:
+http://wiki.bazaar.canonical.com/Workflows:
 
 .. pull-quote::
   In this workflow, each developer has their own branch or
@@ -1411,44 +1037,10 @@
 results.
 
 
-Reviewing Blueprints
-====================
-
-Blueprint Tracking Using Launchpad
-----------------------------------
-
-New features typically require a fair amount of discussion, design and
-debate. For Bazaar, that information is often captured in a so-called
-"blueprint" on our Wiki. Overall tracking of blueprints and their status
-is done using Launchpad's relevant tracker,
-https://blueprints.launchpad.net/bzr/. Once a blueprint for ready for
-review, please announce it on the mailing list.
-
-Alternatively, send an email beginning with [RFC] with the proposal to the
-list. In some cases, you may wish to attach proposed code  or a proposed
-developer document if that best communicates the idea. Debate can then
-proceed using the normal merge review processes.
-
-
-Recording Blueprint Review Feedback
------------------------------------
-
-Unlike its Bug Tracker, Launchpad's Blueprint Tracker doesn't currently
-(Jun 2007) support a chronological list of comment responses. Review
-feedback can either be recorded on the Wiki hosting the blueprints or by
-using Launchpad's whiteboard feature.
-
-
 Planning Releases
 =================
 
 
-Using Releases and Milestones in Launchpad
-------------------------------------------
-
-TODO ... (Exact policies still under discussion)
-
-
 Bug Triage
 ----------
 

=== modified file 'doc/developers/code-review.txt'
--- doc/developers/code-review.txt	2010-05-12 11:04:21 +0000
+++ doc/developers/code-review.txt	2010-05-14 13:34:22 +0000
@@ -1,55 +1,28 @@
-The Code Review Process
-#######################
-
-All code changes coming in to Bazaar are reviewed by someone else.
+Reviewing proposed changes to Bazaar
+####################################
+
+All non-trivial code changes coming in to Bazaar are reviewed by someone else.
+
+Anyone is welcome to review any patch.  You don't need to have a full 
+understanding of the codebase to find problems in the code, the documentation,
+or the concept of the patch.
+
 Normally changes by core contributors are reviewed by one other core
 developer, and changes from other people are reviewed by two core
-developers.  Use intelligent discretion if the patch is trivial.
-
-Good reviews do take time. They also regularly require a solid
-understanding of the overall code base. In practice, this means a small
-number of people often have a large review burden - with knowledge comes
-responsibility. No one likes their merge requests sitting in a queue going
-nowhere, so reviewing sooner rather than later is strongly encouraged.
-
-
-
-Review cover letters
-====================
-
-Please put a "cover letter" on your merge request explaining:
-
-* the reason **why** you're making this change
-
-* **how** this change achieves this purpose
-
-* anything else you may have fixed in passing
-
-* anything significant that you thought of doing, such as a more
-  extensive fix or a different approach, but didn't or couldn't do now
-
-A good cover letter makes reviewers' lives easier because they can decide
-from the letter whether they agree with the purpose and approach, and then
-assess whether the patch actually does what the cover letter says.
-Explaining any "drive-by fixes" or roads not taken may also avoid queries
-from the reviewer.  All in all this should give faster and better reviews.
-Sometimes writing the cover letter helps the submitter realize something
-else they need to do.  The size of the cover letter should be proportional
-to the size and complexity of the patch.
+developers.  Use intelligent discretion about whether if the patch is trivial.
+
+No one likes their merge requests sitting in a queue going nowhere: this 
+is pure waste.  We prioritize reviewing existing proposals.  
+Canonical dedicates some staff time to providing prompt helpful reviews.  
+(See <http://wiki.bazaar.canonical.com/PatchPilot/>.)
+
+From late 2009 on, we do all our code reviews through Launchpad's 
+merge proposal interface.
 
 
 Reviewing proposed changes
 ==========================
 
-Anyone is welcome to review code, and reply to the thread with their
-opinion or comments.
-
-The simplest way to review a proposed change is to just read the patch on
-the list or in Bundle Buggy.  For more complex changes it may be useful
-to make a new working tree or branch from trunk, and merge the proposed
-change into it, so you can experiment with the code or look at a wider
-context.
-
 There are three main requirements for code to get in:
 
 * Doesn't reduce test coverage: if it adds new methods or commands,
@@ -72,7 +45,7 @@
 
 It is easy for reviews to make people notice other things which should be
 fixed but those things should not hold up the original fix being accepted.
-New things can easily be recorded in the Bug Tracker instead.
+New things can easily be recorded in the bug tracker instead.
 
 It's normally much easier to review several smaller patches than one large
 one.  You might want to use ``bzr-loom`` to maintain threads of related
@@ -109,62 +82,23 @@
 Reviews on Launchpad
 ====================
 
-From May 2009 on, we prefer people to propose code reviews through
-Launchpad.
-
- * <https://launchpad.net/+tour/code-review>
-
- * <https://help.launchpad.net/Code/Review>
-
 Anyone can propose or comment on a merge proposal just by creating a
 Launchpad account.
 
-There are two ways to create a new merge proposal: through the web
-interface or by email.
-
-
-Proposing a merge through the web
----------------------------------
-
-To create the proposal through the web, first push your branch to Launchpad.
-For example, a branch dealing with documentation belonging to the Launchpad
-User mbp could be pushed as ::
-
-  bzr push lp:~mbp/bzr/doc
-
-Then go to the branch's web page, which in this case would be
-<https://code.launchpad.net/~mbp/bzr/doc>.  You can simplify this step by just
-running ::
-
-  bzr lp-open
-
-You can then click "Propose for merging into another branch", and enter your
-cover letter (see above) into the web form.  Typically you'll want to merge
-into ``~bzr/bzr/trunk`` which will be the default; you might also want to
-nominate merging into a release branch for a bug fix.  There is the option to
-specify a specific reviewer or type of review, and you shouldn't normally
-change those.
-
-Submitting the form takes you to the new page about the merge proposal
-containing the diff of the changes, comments by interested people, and
-controls to comment or vote on the change.
-
-Proposing a merge by mail
--------------------------
-
-To propose a merge by mail, send a bundle to ``merge@code.launchpad.net``.
-
-You can generate a merge request like this::
-
-  bzr send -o bug-1234.diff
-
-``bzr send`` can also send mail directly if you prefer; see the help.
-
-Reviewing changes
------------------
-
 From <https://code.launchpad.net/bzr/+activereviews> you can see all
 currently active reviews, and choose one to comment on.  This page also
 shows proposals that are now approved and should be merged by someone with
 PQM access.
 
+<https://help.launchpad.net/Code/Review> explains the various merge proposal
+states.  Note that we don't use state *Approved* until the patch is completely
+ready to merge.
+
+
+Landing approved changes
+========================
+
+Once a merge proposal is approved and finished, it's sent to PQM (the patch
+queue manager) which will automatically test and integrate it.  The recommended
+way to start this off is by running the ``feed-pqm`` script from 
+<https://launchpad.net/hydrazine/>.

=== added file 'doc/developers/code-style.txt'
--- doc/developers/code-style.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/code-style.txt	2010-05-27 04:55:13 +0000
@@ -0,0 +1,427 @@
+***********************
+Bazaar Code Style Guide
+***********************
+
+Code layout
+===========
+
+Please write PEP-8__ compliant code.
+
+__ http://www.python.org/peps/pep-0008.html
+
+One often-missed requirement is that the first line of docstrings
+should be a self-contained one-sentence summary.
+
+We use 4 space indents for blocks, and never use tab characters.  (In vim,
+``set expandtab``.)
+
+Trailing white space should be avoided, but is allowed.
+You should however not make lots of unrelated white space changes.
+
+Unix style newlines (LF) are used.
+
+Each file must have a newline at the end of it.
+
+Lines should be no more than 79 characters if at all possible.
+Lines that continue a long statement may be indented in either of
+two ways:
+
+within the parenthesis or other character that opens the block, e.g.::
+
+    my_long_method(arg1,
+                   arg2,
+                   arg3)
+
+or indented by four spaces::
+
+    my_long_method(arg1,
+        arg2,
+        arg3)
+
+The first is considered clearer by some people; however it can be a bit
+harder to maintain (e.g. when the method name changes), and it does not
+work well if the relevant parenthesis is already far to the right.  Avoid
+this::
+
+     self.legbone.kneebone.shinbone.toebone.shake_it(one,
+                                                     two,
+                                                     three)
+
+but rather ::
+
+     self.legbone.kneebone.shinbone.toebone.shake_it(one,
+         two,
+         three)
+
+or ::
+
+     self.legbone.kneebone.shinbone.toebone.shake_it(
+         one, two, three)
+
+For long lists, we like to add a trailing comma and put the closing
+character on the following line.  This makes it easier to add new items in
+future::
+
+    from bzrlib.goo import (
+        jam,
+        jelly,
+        marmalade,
+        )
+
+There should be spaces between function parameters, but not between the
+keyword name and the value::
+
+    call(1, 3, cheese=quark)
+
+
+Python versions
+===============
+
+Bazaar supports Python from 2.4 through 2.6, and in the future we want to
+support Python 3.0.  Avoid using language features added in 2.5 or 2.6, or
+features deprecated in Python 3.0.  (You can check v3 compatibility using
+the ``-3`` option of Python2.6.)
+
+Specifically:
+
+ * Don't use the ``with`` statement.
+
+ * Don't ``from . import``.
+
+ * Don't use ``try/except/finally``, which is not supported in Python2.4,
+   use separate nested ``try/except`` and ``try/finally`` blocks.
+
+
+hasattr and getattr
+===================
+
+``hasattr`` should not be used because it swallows exceptions including
+``KeyboardInterrupt``.  Instead, say something like ::
+
+  if getattr(thing, 'name', None) is None
+
+
+Module Imports
+==============
+
+* Imports should be done at the top-level of the file, unless there is
+  a strong reason to have them lazily loaded when a particular
+  function runs.  Import statements have a cost, so try to make sure
+  they don't run inside hot functions.
+
+* Module names should always be given fully-qualified,
+  i.e. ``bzrlib.hashcache`` not just ``hashcache``.
+
+
+Naming
+======
+
+Functions, methods or members that are relatively private are given
+a leading underscore prefix.  Names without a leading underscore are
+public not just across modules but to programmers using bzrlib as an
+API.
+
+We prefer class names to be concatenated capital words (``TestCase``)
+and variables, methods and functions to be lowercase words joined by
+underscores (``revision_id``, ``get_revision``).
+
+For the purposes of naming some names are treated as single compound
+words: "filename", "revno".
+
+Consider naming classes as nouns and functions/methods as verbs.
+
+Try to avoid using abbreviations in names, because there can be
+inconsistency if other people use the full name.
+
+
+Standard Names
+==============
+
+``revision_id`` not ``rev_id`` or ``revid``
+
+Functions that transform one thing to another should be named ``x_to_y``
+(not ``x2y`` as occurs in some old code.)
+
+
+Destructors
+===========
+
+Python destructors (``__del__``) work differently to those of other
+languages.  In particular, bear in mind that destructors may be called
+immediately when the object apparently becomes unreferenced, or at some
+later time, or possibly never at all.  Therefore we have restrictions on
+what can be done inside them.
+
+ 0. If you think you need to use a ``__del__`` method ask another
+    developer for alternatives.  If you do need to use one, explain
+    why in a comment.
+
+ 1. Never rely on a ``__del__`` method running.  If there is code that
+    must run, do it from a ``finally`` block instead.
+
+ 2. Never ``import`` from inside a ``__del__`` method, or you may crash the
+    interpreter!!
+
+ 3. In some places we raise a warning from the destructor if the object
+    has not been cleaned up or closed.  This is considered OK: the warning
+    may not catch every case but it's still useful sometimes.
+
+
+Cleanup methods
+===============
+
+Often when something has failed later code, including cleanups invoked
+from ``finally`` blocks, will fail too.  These secondary failures are
+generally uninteresting compared to the original exception.  So use the
+``only_raises`` decorator (from ``bzrlib.decorators``) for methods that
+are typically called in ``finally`` blocks, such as ``unlock`` methods.
+For example, ``@only_raises(LockNotHeld, LockBroken)``.  All errors that
+are unlikely to be a knock-on failure from a previous failure should be
+allowed.
+
+
+Factories
+=========
+
+In some places we have variables which point to callables that construct
+new instances.  That is to say, they can be used a lot like class objects,
+but they shouldn't be *named* like classes.  Things called ``FooBar`` should
+create an instance of ``FooBar``.  A factory method that might create a
+``FooBar`` or might make something else should be called ``foo_factory``.
+
+
+Registries
+==========
+
+Several places in Bazaar use (or will use) a registry, which is a
+mapping from names to objects or classes.  The registry allows for
+loading in registered code only when it's needed, and keeping
+associated information such as a help string or description.
+
+
+InterObject and multiple dispatch
+=================================
+
+The ``InterObject`` provides for two-way `multiple dispatch`__: matching
+up for example a source and destination repository to find the right way
+to transfer data between them.
+
+.. __: http://en.wikipedia.org/wiki/Multiple_dispatch
+
+There is a subclass ``InterObject`` classes for each type of object that is
+dispatched this way, e.g. ``InterRepository``.  Calling ``.get()`` on this
+class will return an ``InterObject`` instance providing the best match for
+those parameters, and this instance then has methods for operations
+between the objects.
+
+::
+
+  inter = InterRepository.get(source_repo, target_repo)
+  inter.fetch(revision_id)
+
+``InterRepository`` also acts as a registry-like object for its
+subclasses, and they can be added through ``.register_optimizer``.  The
+right one to run is selected by asking each class, in reverse order of
+registration, whether it ``.is_compatible`` with the relevant objects.
+
+Lazy Imports
+============
+
+To make startup time faster, we use the ``bzrlib.lazy_import`` module to
+delay importing modules until they are actually used. ``lazy_import`` uses
+the same syntax as regular python imports. So to import a few modules in a
+lazy fashion do::
+
+  from bzrlib.lazy_import import lazy_import
+  lazy_import(globals(), """
+  import os
+  import subprocess
+  import sys
+  import time
+
+  from bzrlib import (
+     errors,
+     transport,
+     revision as _mod_revision,
+     )
+  import bzrlib.transport
+  import bzrlib.xml5
+  """)
+
+At this point, all of these exist as a ``ImportReplacer`` object, ready to
+be imported once a member is accessed. Also, when importing a module into
+the local namespace, which is likely to clash with variable names, it is
+recommended to prefix it as ``_mod_<module>``. This makes it clearer that
+the variable is a module, and these object should be hidden anyway, since
+they shouldn't be imported into other namespaces.
+
+While it is possible for ``lazy_import()`` to import members of a module
+when using the ``from module import member`` syntax, it is recommended to
+only use that syntax to load sub modules ``from module import submodule``.
+This is because variables and classes can frequently be used without
+needing a sub-member for example::
+
+  lazy_import(globals(), """
+  from module import MyClass
+  """)
+
+  def test(x):
+      return isinstance(x, MyClass)
+
+This will incorrectly fail, because ``MyClass`` is a ``ImportReplacer``
+object, rather than the real class.
+
+It also is incorrect to assign ``ImportReplacer`` objects to other variables.
+Because the replacer only knows about the original name, it is unable to
+replace other variables. The ``ImportReplacer`` class will raise an
+``IllegalUseOfScopeReplacer`` exception if it can figure out that this
+happened. But it requires accessing a member more than once from the new
+variable, so some bugs are not detected right away.
+
+
+The Null revision
+=================
+
+The null revision is the ancestor of all revisions.  Its revno is 0, its
+revision-id is ``null:``, and its tree is the empty tree.  When referring
+to the null revision, please use ``bzrlib.revision.NULL_REVISION``.  Old
+code sometimes uses ``None`` for the null revision, but this practice is
+being phased out.
+
+
+Object string representations
+=============================
+
+Python prints objects using their ``__repr__`` method when they are
+written to logs, exception tracebacks, or the debugger.  We want
+objects to have useful representations to help in determining what went
+wrong.
+
+If you add a new class you should generally add a ``__repr__`` method
+unless there is an adequate method in a parent class.  There should be a
+test for the repr.
+
+Representations should typically look like Python constructor syntax, but
+they don't need to include every value in the object and they don't need
+to be able to actually execute.  They're to be read by humans, not
+machines.  Don't hardcode the classname in the format, so that we get the
+correct value if the method is inherited by a subclass.  If you're
+printing attributes of the object, including strings, you should normally
+use ``%r`` syntax (to call their repr in turn).
+
+Try to avoid the representation becoming more than one or two lines long.
+(But balance this against including useful information, and simplicity of
+implementation.)
+
+Because repr methods are often called when something has already gone
+wrong, they should be written somewhat more defensively than most code.
+The object may be half-initialized or in some other way in an illegal
+state.  The repr method shouldn't raise an exception, or it may hide the
+(probably more useful) underlying exception.
+
+Example::
+
+    def __repr__(self):
+        return '%s(%r)' % (self.__class__.__name__,
+                           self._transport)
+
+
+Exception handling
+==================
+
+A bare ``except`` statement will catch all exceptions, including ones that
+really should terminate the program such as ``MemoryError`` and
+``KeyboardInterrupt``.  They should rarely be used unless the exception is
+later re-raised.  Even then, think about whether catching just
+``Exception`` (which excludes system errors in Python2.5 and later) would
+be better.
+
+
+Test coverage
+=============
+
+All code should be exercised by the test suite.  See the `Bazaar Testing
+Guide <http://doc.bazaar.canonical.com/developers/testing.html>`_ for detailed
+information about writing tests.
+
+
+Assertions
+==========
+
+Do not use the Python ``assert`` statement, either in tests or elsewhere.
+A source test checks that it is not used.  It is ok to explicitly raise
+AssertionError.
+
+Rationale:
+
+ * It makes the behaviour vary depending on whether bzr is run with -O
+   or not, therefore giving a chance for bugs that occur in one case or
+   the other, several of which have already occurred: assertions with
+   side effects, code which can't continue unless the assertion passes,
+   cases where we should give the user a proper message rather than an
+   assertion failure.
+ * It's not that much shorter than an explicit if/raise.
+ * It tends to lead to fuzzy thinking about whether the check is
+   actually needed or not, and whether it's an internal error or not
+ * It tends to cause look-before-you-leap patterns.
+ * It's unsafe if the check is needed to protect the integrity of the
+   user's data.
+ * It tends to give poor messages since the developer can get by with
+   no explanatory text at all.
+ * We can't rely on people always running with -O in normal use, so we
+   can't use it for tests that are actually expensive.
+ * Expensive checks that help developers are better turned on from the
+   test suite or a -D flag.
+ * If used instead of ``self.assert*()`` in tests it makes them falsely pass with -O.
+
+emacs setup
+===========
+
+In emacs::
+
+    ;(defface my-invalid-face
+    ;  '((t (:background "Red" :underline t)))
+    ;  "Face used to highlight invalid constructs or other uglyties"
+    ;  )
+
+    (defun my-python-mode-hook ()
+     ;; setup preferred indentation style.
+     (setq fill-column 79)
+     (setq indent-tabs-mode nil) ; no tabs, never, I will not repeat
+    ;  (font-lock-add-keywords 'python-mode
+    ;                         '(("^\\s *\t" . 'my-invalid-face) ; Leading tabs
+    ;                            ("[ \t]+$" . 'my-invalid-face)  ; Trailing spaces
+    ;                            ("^[ \t]+$" . 'my-invalid-face)); Spaces only
+    ;                          )
+     )
+
+    (add-hook 'python-mode-hook 'my-python-mode-hook)
+
+The lines beginning with ';' are comments. They can be activated
+if one want to have a strong notice of some tab/space usage
+violations.
+
+Portability Tips
+================
+
+The ``bzrlib.osutils`` module has many useful helper functions, including
+some more portable variants of functions in the standard library.
+
+In particular, don't use ``shutil.rmtree`` unless it's acceptable for it
+to fail on Windows if some files are readonly or still open elsewhere.
+Use ``bzrlib.osutils.rmtree`` instead.
+
+Using the ``open(..).read(..)`` or ``open(..).write(..)`` style chaining
+of methods for reading or writing file content relies on garbage collection
+to close the file which may keep the file open for an undefined period of
+time. This may break some follow up operations like rename on Windows.
+Use ``try/finally`` to explictly close the file. E.g.::
+
+    f = open('foo.txt', 'w')
+    try:
+        f.write(s)
+    finally:
+        f.close()
+
+..
+   vim: ft=rst tw=74 ai

=== modified file 'doc/developers/index-plain.txt'
--- doc/developers/index-plain.txt	2010-05-12 11:04:21 +0000
+++ doc/developers/index-plain.txt	2010-05-15 10:57:30 +0000
@@ -26,6 +26,8 @@
 
 * `Code Review <code-review.html>`_.
 
+* `Bazaar Code Style Guide <code-style.html>`_.
+
 * `Writing plugins <http://doc.bazaar.canonical.com/plugins/en/plugin-development.html>`_
   |--| specific advice on writing Bazaar plugins. (web link)
 

=== modified file 'doc/developers/index.txt'
--- doc/developers/index.txt	2010-05-12 11:04:21 +0000
+++ doc/developers/index.txt	2010-05-15 10:57:30 +0000
@@ -24,6 +24,7 @@
    HACKING
    testing
    code-review
+   code-style
 
 * `Contributing to Bazaar Documentation <http://wiki.bazaar.canonical.com/ContributingToTheDocs>`_ (wiki)
 

=== modified file 'doc/developers/integration.txt'
--- doc/developers/integration.txt	2009-09-15 06:07:11 +0000
+++ doc/developers/integration.txt	2010-05-16 09:29:44 +0000
@@ -2,8 +2,35 @@
 Integrating with Bazaar
 =======================
 
-This page should hopefully become a quick guide to integrating other
-(Python-based) software with Bazaar.
+This document provides some general observations on integrating with
+Bazaar and some recipes for typical tasks.  It is intended to be useful to
+someone developing either a plugin or some other piece of software that
+integrates with bzr.  If you want to know about a topic that's not covered
+here, just ask us.
+
+
+
+
+Starting with bzrlib
+====================
+
+Before doing anything else with bzrlib, you should run `bzrlib.initialize`
+which sets up some global state.  
+
+
+Running bzr commands
+====================
+
+To run command-line commands in-process::
+
+  from bzrlib.commands import get_command
+  
+  cmd = get_command('version')
+  cmd.run([])
+  
+This will send output through the current UIFactory; you can redirect this
+elsewhere through the parameters to `bzrlib.initialize`.
+
 
 Manipulating the Working Tree
 =============================
@@ -21,7 +48,8 @@
 to see which methods are available.
 
 Compare trees
-===============
+-------------
+
 There are two methods for comparing trees: ``changes_from`` and
 ``iter_changes``.  ``iter_changes`` is more regular and precise, but it is
 somewhat harder to work with.  See the API documentation for more details.
@@ -54,7 +82,7 @@
 
 
 Adding Files
-============
+------------
 
 If you want to add files the same way ``bzr add`` does, you can use
 MutableTree.smart_add.  By default, this is recursive. Paths can either be
@@ -70,7 +98,7 @@
 
 
 Removing Files
-==============
+--------------
 
 You can remove multiple files at once.  The file paths need to be relative
 to the workingtree::
@@ -85,7 +113,7 @@
 
 
 Renaming a File
-===============
+---------------
 
 You can rename one file to a different name using WorkingTree.rename_one.
 You just provide the old and new names, eg::
@@ -94,7 +122,7 @@
 
 
 Moving Files
-============
+------------
 
 You can move multiple files from one directory into another using
 WorkingTree.move::
@@ -107,7 +135,7 @@
 
 
 Committing Changes
-==================
+------------------
 
 To commit _all_ the changes to our working tree we can just call the
 WorkingTree's commit method, giving it a commit message, eg::
@@ -187,7 +215,7 @@
 
 
 Branching from an existing branch
-=================================
+---------------------------------
 
 To branch you create a branch object representing the branch you are
 branching from, and supply a path/url to the new branch location.
@@ -205,7 +233,7 @@
 
 
 Pushing and pulling branches
-============================
+----------------------------
 
 To push a branch you need to open the source and destination branches, then
 just call push with the other branch as a parameter::

=== modified file 'doc/developers/overview.txt'
--- doc/developers/overview.txt	2009-12-02 20:34:07 +0000
+++ doc/developers/overview.txt	2010-05-23 20:44:49 +0000
@@ -4,36 +4,20 @@
 
 This document describes the key classes and concepts within Bazaar.  It is
 intended to be useful to people working on the Bazaar codebase, or to
-people writing plugins.
+people writing plugins.  People writing plugins may also like to read the 
+guide to `Integrating with Bazaar <integrating.html>`_ for some specific
+recipes.
 
 If you have any questions, or if something seems to be incorrect, unclear
 or missing, please talk to us in ``irc://irc.freenode.net/#bzr``, or write
-to the Bazaar mailing list.  To propose a correction or addition to this
-document, send a merge request or new text to the mailing list.
-
-The current version of this document is available in the file
-``doc/developers/overview.txt`` in the source tree, and available online
-within the developer documentation, <http://doc.bazaar-vcs.org/developers/>.
-
-
-Essential Domain Classes
-########################
-
-The core domain objects within the bazaar model are:
-
-* Transport
-
-* Branch
-
-* Repository
-
-* WorkingTree
-
-Transports are explained below. See http://bazaar-vcs.org/Classes/
-for an introduction to the other key classes.
+to the Bazaar mailing list.  
+
+
+Core classes
+############
 
 Transport
-#########
+=========
 
 The ``Transport`` layer handles access to local or remote directories.
 Each Transport object acts as a logical connection to a particular
@@ -46,7 +30,7 @@
 Python file I/O mechanisms.
 
 Filenames vs URLs
-=================
+-----------------
 
 Transports work in terms of URLs.  Take note that URLs are by definition
 only ASCII - the decision of how to encode a Unicode string into a URL
@@ -83,14 +67,66 @@
 is also in the form of URL components.
 
 
+WorkingTree
+===========
+
+A workingtree is a special type of Tree that's associated with a working
+directory on disk, where the user can directly modify the files. 
+
+Responsibilities:
+
+ * Maintaining a WorkingTree on disk at a file path.
+ * Maintaining the basis inventory (the inventory of the last commit done)
+ * Maintaining the working inventory.
+ * Maintaining the pending merges list.
+ * Maintaining the stat cache.
+ * Maintaining the last revision the working tree was updated to.
+ * Knows where its Branch is located.
+
+Dependencies:
+
+ * a Branch
+ * an MutableInventory
+ * local access to the working tree
+
+Branch
+======
+
+A Branch is a key user concept - its a single line of history that one or
+more people have been committing to. 
+
+A Branch is responsible for:
+
+ * Holding user preferences that are set in a Branch.
+ * Holding the 'tip': the last revision to be committed to this Branch. (And the revno of that revision.)
+ * Knowing how to open the Repository that holds its history.
+ * Allowing write locks to be taken out to prevent concurrent alterations to the branch.
+
+Depends on:
+ * URL access to its base directory.
+ * A Transport to access its files.
+ * A Repository to hold its history.
+
 Repository
-##########
+==========
 
 Repositories store committed history: file texts, revisions, inventories,
-and graph relationships between them.
+and graph relationships between them.  A repository holds a bag of
+revision data that can be pointed to by various branches:
+
+ * Maintains storage of various history data at a URL:
+   * Revisions (Must have a matching inventory)
+   * Digital Signatures
+   * Inventories for each Revision. (Must have all the file texts available).
+   * File texts
+
+ * Synchronizes concurrent access to the repository by different
+   processes.  (Most repository implementations use a physical 
+   mutex only for a short period, and effectively support multiple readers
+   and writers.)
 
 Stacked Repositories
-====================
+--------------------
 
 A repository can be configured to refer to a list of "fallback"
 repositories.  If a particular revision is not present in the original

=== modified file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2010-03-17 02:58:08 +0000
+++ doc/developers/releasing.txt	2010-05-27 19:54:56 +0000
@@ -1,5 +1,5 @@
 Releasing Bazaar
-================
+################
 
 This document describes the processes for making and announcing a Bazaar
 release, and managing the release process.  This is just one phase of the
@@ -19,46 +19,37 @@
 
 
 Preconditions
--------------
+=============
 
 #. Download the pqm plugin and install it into your ``~/.bazaar/plugins``::
 
      bzr branch lp:bzr-pqm ~/.bazaar/plugins/pqm
 
 
-Starting a cycle
-----------------
+At the start of a release cycle
+===============================
 
 To start a new release cycle:
 
-#. Create a new series at <https://launchpad.net/bzr/+addseries>. There is one
-   series for every *x.y* release.
-
-#. Go to the series web page at <https://launchpad.net/bzr/x.y>
-
-#. Create a new release at
-   <https://launchpad.net/bzr/x.y/+addrelease> and add
-   information about this release. We will not use it yet, but it
+#. If this is the first release for a given *x.y* then create a new
+   series at <https://launchpad.net/bzr/+addseries>. There is one series
+   for every *x.y* release.
+
+#. If you made a new series, create a new pqm-controlled branch for this
+   release series, by asking a Canonical sysadmin.  This branch means that
+   from the first release beta or candidate onwards, general development
+   continues on the trunk, and only specifically-targeted fixes go into
+   the release branch.
+
+#. If you made a new series, add milestones at
+   <https://edge.launchpad.net/bzr/x.y/+addmilestone> to that series for
+   the beta release, release candidate and the final release, and their
+   expected dates.
+
+#. Create a new milestone <https://edge.launchpad.net/bzr/x.y/+addmilestone>
+   and add information about this release.  We will not use it yet, but it
    will be available for targeting or nominating bugs.
 
-#. We create a new pqm-controlled branch for this release series, by
-   asking a Canonical sysadmin.
-   This branch means that from the first release beta or candidate onwards,
-   general development continues on the trunk, and only
-   specifically-targeted fixes go into the release branch.
-
-#. Add milestones at <https://edge.launchpad.net/bzr/x.y/+addmilestone> to
-   that series for the beta release, release candidate and the final release,
-   and their expected dates.
-
-#. Update the version number in the ``bzr`` script, and the
-   ``bzrlib/__init__.py`` file. Make sure there is always a corresponding
-   milestone when you change that version number.
-
-#. Add a new section at the top of ``NEWS`` about the new release,
-   including its version number and the headings from
-   ``NEWS-template.txt``.
-
 #. Send mail to the list with the key dates, who will be the release
    manager, and the main themes or targeted bugs.  Ask people to nominate
    objectives, or point out any high-risk things that are best done early,
@@ -71,7 +62,7 @@
      bzr branch trunk prepare-1.14
 
 #. Configure pqm-submit for this branch, with a section like this (where
-   x.y is the version to release).
+   x.y is the version to release). **Or use hydrazine for easy use**
    ``~/.bazaar/locations.conf``::
 
 	[/home/mbp/bzr/prepare-x.y]
@@ -85,6 +76,29 @@
     Please see <http://doc.bazaar-vcs.org/developers/HACKING.html#an-overview-of-pqm>
     for more details on PQM
 
+#. Update the version number in the ``bzr`` script, and the
+   ``bzrlib/__init__.py`` file::
+   
+       version_info = (x, y, z, 'dev', 0)
+   
+#. Add a new section at the top of ``NEWS`` about the new release,
+   including its version number and the headings from
+   ``NEWS-template.txt``.
+
+#. Commit this and send it to PQM.
+
+
+Doing a particular release
+==========================
+
+Update the source code
+----------------------
+
+#. Check that there is a milestone for the release you're doing. If there
+   is no milestone it indicates a process problem - make the milestone but
+   also mail the list to raise this issue in our process. Milestones are
+   found at <https://launchpad.net/bzr/+milestone/x.y.z>.
+
 #. In the release branch, update  ``version_info`` in ``./bzrlib/__init__.py``.
    Make sure the corresponding milestone exists.
    Double check that ./bzr ``_script_version`` matches ``version_info``. Check
@@ -92,40 +106,37 @@
 
    For beta releases use::
 
+       version_info = (2, 1, 0, 'beta', SERIAL)
+
+   For instance 2.1b1::
+
        version_info = (2, 1, 0, 'beta', 1)
 
-
    For release candidates use::
 
-       version_info = (2, 0, 1, 'candidate', 1)
-
-
-Starting the release phase
---------------------------
-
-#. Create a new milestone at <https://launchpad.net/bzr/x.y/+addmilestone>
-   for the beta release or release candidate if you haven't already.
-
-#. Add the date and release number to ``./NEWS``
-
-   Depending on whether you're doing a beta or a bugfix release, you'll
-   have to create a NEWS section for your release in the right
-   place. Most of the time, the new section is at the top of the file
-   (look what have been done for the various 2.0x and 2.1.0bx releases).
-   The rule is to keep the sections sorted by date. You'll need to be
-   cautious when merging back to trunk to respect that.
+       version_info = (2, 0, 1, 'candidate', SERIAL)
+
+   For stable releases use::
+
+       version_info = (2, 1, 2, 'final', 0)
+
+#. Check the release number in ``./NEWS``
+
+   Fill out the date and a description of the release under the existing
+   header. If there isn't one, follow the above for using the NEWS
+   template.
+
+   See *2.1.1* or similar for an example of what this looks like.
 
 #. To check that all bugs mentioned in ``./NEWS`` are actually marked as
    closed in Launchpad, you can run ``tools/check-newsbugs.py``::
 
      ./tools/check-newsbugs.py NEWS
 
-   (But note there can be some false positives, and this script may be
+   (But note there will be many false positives, and this script may be
    flaky <https://bugs.edge.launchpad.net/bzr/+bug/354985>.  Don't let
    this slow you down too much.)
 
-#. Summarize into one or two paragraphs what's new in this release.
-
 #. Commit these changes to the release branch, using a command like::
 
      bzr commit -m "Release 1.14."
@@ -170,7 +181,7 @@
 
      bzr tag bzr-1.14
 
-#. Push those changes to a bzr reposistory that is public and accessible on
+#. Push those changes to a bzr repository that is public and accessible on
    the Internet. PQM will pull from this repository when it attempts to merge
    your changes. Then submit those changes to PQM for merge into the
    appropriate release branch::
@@ -178,6 +189,11 @@
      bzr push
      bzr pqm-submit -m "(mbp) prepare 1.14"
 
+   Or with hydrazine::
+
+     bzr lp-propose -m "Release 1.14" --approve lp:bzr/1.14
+     feed-pqm bzr
+
 #. When PQM succeeds, pull down the master release branch.
 
 
@@ -199,15 +215,24 @@
    disable the faulty plugins one by one until you get no more
    failures.
 
+   Remember that PQM has just tested everything too, this step is
+   particularly testing that the pyrex extensions, which are updated
+   by your local pyrex version when you run make dist, are in good
+   shape.
+
 
 Publishing the source tarball
 -----------------------------
 
 #. Go to the relevant milestone page in Launchpad.
 
-#. Within that release, upload the source tarball and the GPG
-   signature.  Or, if you prefer, use the
-   ``tools/packaging/lp-upload-release`` script to do this.
+#. Create a release of the milestone, and upload the source tarball and
+   the GPG signature.  Or, if you prefer, use the
+   ``tools/packaging/lp-upload-release`` script to do this. Note that
+   this changes what the download widget on the Launchpad bzr home
+   page shows, so don't stop the release process yet, or platform binary
+   installers won't be made and the download list will stay very small!
+   <https://bugs.edge.launchpad.net/launchpad/+bug/586445>
 
 
 Announcing the source freeze
@@ -219,6 +244,15 @@
    release.
 
 
+Kick off the next cycle
+-----------------------
+
+#. To let developers work on the next release, do
+   `At the start of a release cycle` now.
+
+#. Pause for a few days.
+
+
 Publishing the release
 ----------------------
 
@@ -227,11 +261,7 @@
 we have a releasable product.  The next step is to make it generally
 available to the world.
 
-go to the release
-
-#. Within that release, upload the source tarball and zipfile and the GPG
-   signature.  Or, if you prefer, use the
-   ``tools/packaging/lp-upload-release`` script to do this.
+#. Go to the release web page at <https://launchpad.net/bzr/x.y/x.y.z>
 
 #. Link from http://bazaar-vcs.org/SourceDownloads to the tarball and
    signature.
@@ -270,7 +300,7 @@
 
    The announce mail will look something like this::
 
-      Subject: bzr x.yy released!
+      Subject: bzr x.y.z released!
 
       <<Summary paragraph from news>>
 
@@ -318,6 +348,9 @@
 Merging the released code back to trunk
 ---------------------------------------
 
+The rule is to keep ``NEWS`` sections sorted by date. You'll need to
+review the merge and make sure that that is respected.
+
 Merge the release branch back into the trunk.  Check that changes in NEWS
 were merged into the right sections.  If it's not already done, advance
 the version number in ``bzr`` and ``bzrlib/__init__.py``.  Submit this
@@ -327,7 +360,7 @@
 created the corresponding milestone to ensure the continuity in bug
 targeting or nominating. Depending on the change, you may even have to
 create a new series (if your change the major or minor release number), in
-that case go to `Starting a cycle` and follow the instructions from there.
+that case go to `At the start of a release cycle` and follow the instructions from there.
 
 You should also merge (not pull) the release branch into
 ``lp:~bzr/bzr/current``, so that branch contains the current released code
@@ -341,8 +374,8 @@
 candidate, you're not finished yet. Another beta or candidate or
 hopefully a final release is still to come.
 
-The process is the same as for the first release. Goto `Starting the
-release phase`_ and follow the instructions again. Some details change
+The process is the same as for the first release. Goto `Doing a
+particular release`_ and follow the instructions again. Some details change
 between beta, candidate and final releases, but they should be
 documented. If the instructions aren't clear enough, please fix them.
 

=== modified file 'doc/en/conf.py'
--- doc/en/conf.py	2010-03-03 04:18:28 +0000
+++ doc/en/conf.py	2010-05-26 04:26:59 +0000
@@ -54,7 +54,7 @@
   # Manuals
   ('user-guide/index', 'bzr-%s-user-guide.tex' % (bzr_locale,),
     bzr_title(u'Bazaar User Guide'), bzr_team, 'manual'),
-  ('user-reference/bzr_man', 'bzr-%s-user-reference.tex' % (bzr_locale,),
+  ('user-reference/index', 'bzr-%s-user-reference.tex' % (bzr_locale,),
     bzr_title(u'Bazaar User Reference'), bzr_team, 'manual'),
   ('release-notes/NEWS', 'bzr-%s-release-notes.tex' % (bzr_locale,),
     bzr_title(u'Bazaar Release Notes'), bzr_team, 'manual'),

=== modified file 'setup.py'
--- setup.py	2010-04-19 21:04:31 +0000
+++ setup.py	2010-05-27 02:00:27 +0000
@@ -532,17 +532,15 @@
             install_data.run(self)
 
             py2exe = self.distribution.get_command_obj('py2exe', False)
-            optimize = py2exe.optimize
+            # GZ 2010-04-19: Setup has py2exe.optimize as 2, but give plugins
+            #                time before living with docstring stripping
+            optimize = 1
             compile_names = [f for f in self.outfiles if f.endswith('.py')]
             byte_compile(compile_names,
                          optimize=optimize,
                          force=self.force, prefix=self.install_dir,
                          dry_run=self.dry_run)
-            if optimize:
-                suffix = 'o'
-            else:
-                suffix = 'c'
-            self.outfiles.extend([f + suffix for f in compile_names])
+            self.outfiles.extend([f + 'o' for f in compile_names])
     # end of class install_data_with_bytecompile
 
     target = py2exe.build_exe.Target(script = "bzr",
@@ -690,7 +688,7 @@
                                "excludes": excludes,
                                "dll_excludes": dll_excludes,
                                "dist_dir": "win32_bzr.exe",
-                               "optimize": 1,
+                               "optimize": 2,
                               },
                    }
 

